VERSION 5.00
Begin VB.Form frmDDraw 
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   Caption         =   "0"
   ClientHeight    =   7200
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   9600
   LinkTopic       =   "Form1"
   ScaleHeight     =   480
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   640
   ShowInTaskbar   =   0   'False
End
Attribute VB_Name = "frmDDraw"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'Controls:  Arrow keys - navigation.  The meat of the game.
'O key - open/close doors
'Q key - quit prompt
'S key - save your game - requires 1000 points.  If you fall into hole, etc., you go back
'to where you last save.

'Locations:
Option Explicit 'DirectX likes all of its variables to be predefined
Dim binit As Boolean 'A simple flag (true/false) that states whether we've initialized or not. If the initialization is successful
'this changes to true, the program also checks before doing any drawing if this flag is true. If the initialization failed and we
'try and draw things we'll get lots of errors... which is very bad.
'Public FName As String 'Held a filename - was only for demonstration
Public dx As New DirectX7 'This is the root object.  DirectDraw is created from this
Dim dd As DirectDraw7 'This is DirectDraw.  All things DirectDrawish come from here
Dim Mainsurf As DirectDrawSurface7 'This holds our bitmap - the stuff that we TileBlt to the screen
Dim primary As DirectDrawSurface7 'This surface represents the screen - see InitSurfaces
Dim backbuffer As DirectDrawSurface7 'This is mentioned in InitSurfaces as well...
Dim Tiler As DirectDrawSurface7 'this holds our tile information.
Dim Mainpic As DirectDrawSurface7 'this holds our main character!
Dim Effects As DirectDrawSurface7 'this currently holds just an explosion... which we can stretch using DirectDraw
Dim ddsd1 As DDSURFACEDESC2 'this describes the primary surface
Dim ddsd2 As DDSURFACEDESC2 'this describes the bitmap that we load
Dim ddsd3 As DDSURFACEDESC2 'this describes the size of the screen
Dim ddsd4 As DDSURFACEDESC2 'this describes the tiles that we will add
Dim ddsd5 As DDSURFACEDESC2 'this describes the character pictures we will use!
Public XCnt As Integer     'now a looper in Init code and credits... simply clever recycling
Dim brunning As Boolean 'this is another flag that states whether or not the main game loop is running.
Dim CurModeActiveStatus As Boolean 'This checks that we still have the correct display mode
Dim bRestore As Boolean 'If we don't have the correct display mode then this flag states that we need to restore the display mode
Dim DXMode As Byte 'this holds the type of prompting or reordering that we will do at runtime
'For example DXMode = 5 indicates that we have a small caption bar at the bottom of the form.
Dim ActString As String 'this goes with DXMode above.  This is the small captioning that we will
'display when DXMode = 5.  It is a point to refresh this variable when setting DXMode = 5 as it holds the last caption too.
Dim CounterOn As Boolean  'Checks if we are going to scroll.
Dim CountVar As Long        'Scroll position
Dim ClearRed As DDCOLORKEY
'Gamma Controls
Private GammaControler As DirectDrawGammaControl
'The object that gets/sets gamma ramps
Private GammaRamp As DDGAMMARAMP
'The gamma ramp we'll use to alter the screen state
Private OriginalRamp As DDGAMMARAMP
'The gamma ramp we'll use to store the original screen state
Dim gmR As Integer, gmG As Integer, gmB As Integer
'This value determines whether or not to use gamma correction
Private GammaSupport As Boolean
'The clipper handles obscured surfaces and stops our application
'from drawing over the top of other windows.
Dim ddClipper As DirectDrawClipper
Dim LTile As Byte
Dim TTile As Byte
'These numbers specify the far left and top tile numbers that are displayed on the screen...
Dim bAutoKeyed As Boolean
'No key input to the form for navigation keys.
Dim bWalk As Boolean
Dim Walktick As Integer
Dim dWalk As Integer
Dim bScroll As Boolean 'Was the same as walk but except for that small 2x2 space in the middle of the screen
Dim bJustScrolled As Boolean
Dim bFlagged As Boolean
Dim CredScroll As Currency

'Create our library weather.
'Dim Weather As Project44.QWSubs
Sub SetGMColors(ByVal Redset As Integer, ByVal Greenset As Integer, ByVal Blueset As Integer)
gmR = Redset
gmG = Greenset
gmB = Blueset
End Sub
 Sub Init()
'On Local Error GoTo errOut 'If there is an error we end the program.
Set dd = dx.DirectDrawCreate("") 'the ("") means that we want the default driver
Me.Show 'maximises the form and makes sure it's visible
'The first line links the DirectDraw object to our form, It also sets the parameters
'that are to be used - the important ones being DDSCL_FULLSCREEN and DDCSL_EXCLUSIVE. Making it
'exclusive is important, it means that while our application is running nothing else can
'use DirectDraw, and it makes windows give us more time/attention
If WindowMode Then
    Call dd.SetCooperativeLevel(Me.hWnd, DDSCL_NORMAL)
Else
    Call dd.SetCooperativeLevel(Me.hWnd, DDSCL_FULLSCREEN Or DDSCL_ALLOWMODEX Or DDSCL_EXCLUSIVE)
                           'window handle    bit variables  1 ,  64  ,  16  ,  respectively = 81 = Flags
'This is where we actually see a change. It states that we want a display mode
'of 640x480 with 16 bit colour (65536 colours). the fourth argument ("0") is the
'refresh rate. leave this to 0 and DirectX will sort out the best refresh rate. It is advised
'that you don't mess about with this variable. the fifth variable is only used when you
'want to use the more advanced resolutions (usually the lower, older ones)...
    Call dd.SetDisplayMode(640, 480, 16, 0, DDSDM_DEFAULT)
'Taste of eye candy    width,height, bit color, refresh rate, display mode (Default=0 or VGA=1)
End If
'get the screen surface and create a back buffer too
If WindowMode Then
    ddsd1.lFlags = DDSD_CAPS
    ddsd1.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE
Else
    ddsd1.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
    '                      1 Or  32  =  33
    ddsd1.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX
         ''                 512                         16                     8
    ddsd1.lBackBufferCount = 2
End If

'No of backbuffers
Set primary = dd.CreateSurface(ddsd1)
'Creates a surface using surface description ddsd1

'Then we retrieve pointers to the backbuffer. You only need one;
'as directdraw sorts out which one you're drawing to - so you always
'Draw to the same object.

'Get the backbuffer
    Dim caps As DDSCAPS2
If WindowMode = False Then
    caps.lCaps = DDSCAPS_BACKBUFFER   '4
    Set backbuffer = primary.GetAttachedSurface(caps)
    'backbuffer becomes attached to primary with caps of backbuffer
    backbuffer.GetSurfaceDesc ddsd3
Else
    ddsd1.lFlags = DDSD_CAPS + DDSD_HEIGHT + DDSD_WIDTH
    ddsd1.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN + DDSCAPS_VIDEOMEMORY
    ddsd1.lWidth = 640
    ddsd1.lHeight = 480
    Set ddClipper = dd.CreateClipper(0)
    ddClipper.SetHWnd Me.hWnd
    primary.SetClipper ddClipper
End If

CheckForGammaSupport
' init the surfaces
InitSurfaces
SetupGamma
primary.SetFillStyle 0
primary.SetFillColor 0
primary.SetForeColor &HFFFFFF

'This is the main loop. It only runs while brunning=true
binit = True
brunning = True
Do While brunning
If DXMode < 6 Then
    PPrompt
    'This is supposed to update the left & top offset views for the big 120x90 view.
    
    RenderMap 40, 30, 16, 16, Tiler, Mainsurf
    'paint map
'    If SoundOff = False Then
'        LoopRepeatDXMusic -1
'        CheckDXMusic
'        Debug.Print "Sound off"
'    End If
    blt
    
    'draw
    DayClock = DayClock + 1                 'Increment DayClock
    Skilift = SkiPsn(DayClock, MapID)
    Skilift2 = SkiPsn2(DayClock, MapID)     'Set skilifts
    
    If OnLift Then Self = Skilift:     RecalibrateLargeTile 'Check if character is on skilift: move screen
    If OnLift2 Then Self = Skilift2:     RecalibrateLargeTile

    If OnBeast Then EndIt 4               'Onbeast moves beasts and checks if character is touching
    'Careful!  Beasts move 2.5x To 50x as fast as skilifts
    bAutoKeyed = True
    If DayClock Mod 5 = 0 Then
        If Between(Asc(Map(Self.I, Self.J, MapID)), Asc("v"), Asc("y")) Then
            Form_KeyDown Asc(Map(Self.I, Self.J, MapID)) - 81, 0
        ElseIf Between(Asc(Map(Self.I, Self.J, MapID)), 28, 31) Then
            Form_KeyDown Asc(Map(Self.I, Self.J, MapID)) + 9, 0
        ElseIf Asc(Map(Self.I, Self.J, MapID)) = 27 Then
            Form_KeyDown 40, 0
        End If
    End If
    'Rapids effect - presses buttons on the keyboard
    
    If DayClock Mod 30 = 0 Then ToggleFlashes MapID
    'Switches the flash (gray) blocks.
    If DayClock Mod 75 = 0 Then TidalForce MapID
    'Moves the tide in/out
    
    If Map(Self.I, Self.J, MapID) = "Y" And DayClock Mod 2 = 0 Then
        Form_KeyDown 37 + ((SDir + 2) Mod 4), 0
        SDir = (SDir + 2) Mod 4
    End If
    
    If DayClock Mod 5 = 0 And Map(Self.I, Self.J, MapID) = "Z" Then Form_KeyDown SDir + 37, 0
    'Ice effect - keep on sliding
    
    If DayClock Mod 5 = 0 And Map(Self.I, Self.J, MapID) = "z" Then Form_KeyDown 37 + ((SDir + 1) Mod 4), 0
    'Spin tile function check  F(0) = 38        F(1) = 39
    'Function of SDir returns  F(2) = 40        F(3) = 37
    'keycode (spin right and kick off)
    If WindValue(MapID, 0) > 0 And DayClock Mod 20 = 0 Then
        For XCnt = 0 To 2
            If Self.I = WindValue(MapID, XCnt) Then Form_KeyDown 40, 0
            'Wind always blows South.  Presses the down button on your keyboard :)
        Next
    End If
    If DayClock Mod 100 = 0 Then
        If SpreadBlaze(MapID) = 1 Then EndIt 6
    End If
    
    If Not (Walktick = 4 * dWalk) Then Walktick = Walktick + dWalk
        
    If DayClock Mod 5 = 2 Then
        bWalk = False
        dWalk = 4
        Walktick = 0
        KeyDownicEvent
        If InStr(1, "vwxy" & ChrBelts & "Zz") Then dWalk = dWalk + 4
        Walktick = dWalk
    ElseIf DayClock Mod 5 = 1 Or DayClock Mod 5 = 4 Then
        If MoveAllProjies > Extinguisher Then EndIt 7
    End If
    If DayClock Mod 5 = 3 Then
        If DarkMakeMovement(MapID) Then EndIt 8
    End If
     bAutoKeyed = False
ElseIf DXMode = 7 Then
    InitSurfaces
    bWalk = False
    Mainsurf.SetFillColor vbBlue
    Mainsurf.SetFillStyle 0
    Mainsurf.SetForeColor vbYellow
    Mainsurf.DrawBox 16, 16, 656, 496
    Mainsurf.DrawText 16, 640 - 16 * CredScroll, "Quadrill 3 Staff", False
    Mainsurf.DrawText 16, 672 - 16 * CredScroll, "Producer", False
    Mainsurf.DrawText 316, 672 - 16 * CredScroll, "Iceplug", False
    Mainsurf.DrawText 16, 704 - 16 * CredScroll, "Artwork and Graphical Effects", False
    Mainsurf.DrawText 316, 704 - 16 * CredScroll, "Iceplug", False
    Mainsurf.DrawText 316, 720 - 16 * CredScroll, "http://www.directx4vb.com/", False
    Mainsurf.DrawText 16, 752 - 16 * CredScroll, "Music and Sound", False
    Mainsurf.DrawText 316, 752 - 16 * CredScroll, "Iceplug", False
    Mainsurf.DrawText 16, 784 - 16 * CredScroll, "Game Play Design", False
    Mainsurf.DrawText 316, 784 - 16 * CredScroll, "Iceplug", False
    Mainsurf.DrawText 16, 816 - 16 * CredScroll, "Field Design", False
    Mainsurf.DrawText 316, 816 - 16 * CredScroll, "Iceplug", False
    Mainsurf.DrawText 16, 848 - 16 * CredScroll, "Game Writer", False
    Mainsurf.DrawText 316, 848 - 16 * CredScroll, "Iceplug", False
    Mainsurf.DrawText 16, 880 - 16 * CredScroll, "Game Testers", False
    Mainsurf.DrawText 316, 880 - 16 * CredScroll, "Iceplug", False
    Mainsurf.DrawText 16, 896 - 16 * CredScroll, "The good folks at Extreme VB Forums: http://www.visualbasicforum.com/", False
    Mainsurf.DrawText 286, 928 - 16 * CredScroll, "Special Thanks", False
    Mainsurf.DrawText 286, 960 - 16 * CredScroll, "http://www.visualbasicforum.com/", False
    Mainsurf.DrawText 286, 976 - 16 * CredScroll, "http://www.directx4vb.com/", False
    Mainsurf.DrawText 16, 1008 - 16 * CredScroll, "Stay tuned for Quadrill 4", False
    Mainsurf.DrawText 16, 1024 - 16 * CredScroll, "The codes that you have will become valuable in the future.", False
    Mainsurf.DrawText 16, 1040 - 16 * CredScroll, "Congratulations, many blessings, and we hope to see you again....", False
    Mainsurf.DrawText 16, 1088 - 16 * CredScroll, " Iceplug 2003  Iceplug@visualbasicforum.com", False
    
    blt
    
    CredScroll = CredScroll + 0.0625
    If CredScroll >= 68 Then
        MapPrev = 104: MapID = 0
        ActString = "Initializa Plains": DXMode = 5
        StopDXMusic
        ChangeDXMusicFile App.Path & "\adventure.mid"
        LoopRepeatDXMusic -1
        PlayDXMusic
        SetGMColors 0, 0, 0
        TileSet = 0
    End If
End If
DoEvents 'you MUST have a doevents in the loop, otherwise you'll overflow the
'system (which is bad). All your application does is keep sending messages to DirectX
'and windows, if you dont give them time to complete the operation they'll crash.
'adding doevents allows windows to finish doing things that it's doing.
'2,147,483,647  - 'How "long" until variable(DayClock) overflows
'Print 2147483647 / 100  'max of long   'Overshoot frames per second
'Print 21474836.47 / 60  'seconds
'Print 357913.94116_7 / 60 'minutes
'Print 5965.2323527_8 / 24 'hours
'Print 248.551348032408 / 365 'days
'Print 0.680962597349063 'years     'Approximate time for Long character to overflow
' 0.680962597349063   - 'Well, if you play my game long enough for the variable to overflow
'You've been playing a little too long
'Print Not -1 '0000 0001
'0
'-2         '1111 1110
Loop
errOut:
'If there is an error we want to close the program down straight away.
EndIt 9
End Sub
Sub InitSurfaces()
'This procedure may look small, but when you make a program this procedure could
'take a good 60-120 seconds to process, and run into 1000's of lines of code.
Set Mainsurf = Nothing 'Although the first time we call this procedure this
Set Tiler = Nothing ' Initializes our surfaces and the
'variable will be empty, it must be cleared. As you'll see in the blt procedure
'the program may try and re-load the surfaces, at which point the "mainsurf" object
'will have some information in it. If we try and recreate a surface that already has
'information in it DirectDraw will crash, because of this we must clear the buffer first.
ClearRed.high = 8
ClearRed.low = 0

ddsd2.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH 'default flags
                '1              2               4       =    7
ddsd2.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
                        '64  =  Our surface is designed to run offscreenplain
'An offscreenplain means that
'the user never actually gets to see the surface - it is just an area in memory.
If WindowMode Then
    ddsd2.lWidth = 640
    ddsd2.lHeight = 480
Else
    ddsd2.lWidth = ddsd3.lWidth + 32
    ddsd2.lHeight = ddsd3.lHeight + 32
    'This is scaled to bring me closer to having map scrolling.
End If
'this is where the surface is created. You use the DDraw object to create a
'surface from the specified file name using the above description.

Set Mainsurf = dd.CreateSurface(ddsd2)
'Mainsurf is now a 640x480 offscreenplain
ddsd4.lFlags = DDSD_CAPS + DDSD_HEIGHT + DDSD_WIDTH
'Bitwise OR with bits is equivalent to '+'   (7)
ddsd4.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN Or DDSCAPS_VIDEOMEMORY
'Another offscreenplain
ddsd4.lHeight = 160
ddsd4.lWidth = 2048
'This is the exact dimensioning of the paint file. - 2048x160
'If these dimensions are altered or incorrect, the file image will be stretched to this size.

With ddsd5
    .lFlags = DDSD_CAPS + DDSD_HEIGHT + DDSD_WIDTH
    .ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN + DDSCAPS_VIDEOMEMORY
    .lWidth = 64
    .lHeight = 32
End With
'You can also do this with a "WITH" block.
'Another offscreenplain - this one 64x16 -  because it stores 4 16x16 characters

Set Tiler = dd.CreateSurfaceFromFile(App.Path & "\tileset.bmp", ddsd4)
'Now I load these bitmaps to the corresponding surfaces
Set Mainpic = dd.CreateSurfaceFromFile(App.Path & "\picme.bmp", ddsd5)
Mainpic.SetColorKey DDCKEY_SRCBLT, ClearRed
'I can even reuse them
ddsd5.lWidth = 400
ddsd5.lHeight = 64
'This is one is being scaled to 133%.  DirectDraw has keen redrawing ways.  :)
Set Effects = dd.CreateSurfaceFromFile(App.Path & "\explosion.bmp", ddsd5)
Effects.SetColorKey DDCKEY_SRCBLT, ClearRed
End Sub
Sub blt()
'again, this procedure looks fairly simple - it is!
'You should try and keep this procedure as short as possible, and as fast as possible
On Local Error GoTo errOut 'If there is an error don't do anything - just skip
'the procedure
If binit = False Then Exit Sub 'If we haven't initialized then don't try anything
'DirectDraw related.
Dim ddrval As Long 'Every drawing procedure returns a value, so we must have a
'variable to hold it. From this value we can check for errors.

Dim rBack As RECT 'a RECT is the rectangle that i've mentioned.
'Simply replacing width and height with right and bottom

' this will keep us from trying to blt in case we lose the surfaces (alt-tab, ctrl-alt-del)
bRestore = False
Do Until ExModeActive
DoEvents
bRestore = True
Loop

' if we lost and got back the surfaces, then restore them
DoEvents
If bRestore Then
bRestore = False
dd.RestoreAllSurfaces 'this just re-allocates memory back to us. we must
'still reload all the surfaces.
InitSurfaces ' must init the surfaces again if they were lost
End If

Dim Mvx As Long, Mvy As Long
If bWalk And bScroll Then
    Select Case SDir
    Case Direction.LeftDir
        If LTile > -1 And LTile < 81 Then Mvx = 16 - Walktick
    Case Direction.UpDir
        If TTile > -1 And TTile < 61 Then Mvy = 16 - Walktick
    Case Direction.RightDir
        If LTile > -1 And LTile < 81 Then Mvx = Walktick - 16
    Case Direction.DownDir
        If TTile > -1 And TTile < 61 Then Mvy = Walktick - 16
    End Select
End If
'get the area of the screen where our window is
'this sets the rectangle to be the size of the screen.
rBack.Bottom = ddsd3.lHeight + 16 + Mvy
rBack.Right = ddsd3.lWidth + 16 + Mvx
rBack.Left = 16 + Mvx
rBack.Top = 16 + Mvy
'Redo the map to the display - humoring myself... it doesn't work.
'RenderMap 40, 30, 16, 16, primary, backbuffer
'blt to the backbuffer from our surface to
'the screen surface such that our bitmap
'appears over the window

'This Blits to the screen starting from 0,0 on the screen. the DDBLTFAST_WAIT
'flag tells Directdraw to wait if the blitter is busy at the time of the call.
If WindowMode Then
    ddrval = backbuffer.blt(rBack, Mainsurf, rBack, DDBLT_WAIT)
Else
        ddrval = backbuffer.BltFast(0, 0, Mainsurf, rBack, DDBLTFAST_WAIT)
 End If
'The paint stuff!  Mainsurf is blt'dfast or just blt'd to the backbuffer
If DXMode < 6 Or WindowMode = False Then
'flip the back buffer to the screen
'remember that the backbuffer is attached to primary.  Flip will flip primary's
'attached surfaces to its display
    primary.Flip Nothing, DDFLIP_WAIT
ElseIf WindowMode Then
    ddrval = primary.BltFast(0, 0, backbuffer, rBack, DDBLTFAST_WAIT)
End If
'At this point we have completed one graphical cycle, and we can now see something on screen

errOut: 'Skip everything if there is an error. Don't stick a message box in here - because
'you're likely to be running the program at 100's of frames per second, in just one second the
'program will try and generate 100 message boxes...
End Sub
Sub EndIt(ByVal Reason As Byte)
Dim LV As Byte
'This procedure is called at the end of the loop, or whenever there is an error.
'Although you can get away without these few lines it is a good idea to keep them
'as you can get unpredictable results if you leave windows to "clear-up" after you.
If (Reason >= 3 And Reason <= 8) And Tries >= 1 Then
    Tries = Tries - 1
    Self.I = SaveLoc.I
    Self.J = SaveLoc.J
    MapID = SaveLoc.K
    gmR = SaveGrad.I
    gmG = SaveGrad.J
    gmB = SaveGrad.K
    LoadWorld
    ActString = "You have " & Tries + 1 & " tries left."
    DXMode = 5
    For LV = 0 To 9
        Projectile(LV).Activated = False
    Next
'    For LV = 0 To 9
'        DoEvents
'    Next
'
    Exit Sub
End If
'This line restores you back to your default (windows) resolution.
Call dd.RestoreDisplayMode

'This tells windows/directX that we no longer want exclusive access
'to the graphics features/directdraw
Call dd.SetCooperativeLevel(Me.hWnd, DDSCL_NORMAL)

'Stop the program: Shows adapter name in debug if uncommented
'Dim CardName As String, CardGUID As String
'Call GetAdapterInfo(CardName, CardGUID)
'Debug.Print CardName & " :: " & CardGUID
'#If 0 Then
Debug.Print "Your time in frames was: " & DayClock
Debug.Print "Your score was: " & Score
Select Case Reason
Case 1
    Debug.Print "Ended with the Quit button."
Case 2
    Debug.Print "Form was clicked too much."
Case 3
    Debug.Print "Watch out for the holes."
Case 4
    Debug.Print "Watch out for the beast."
Case 5
    Debug.Print "Forfeit with no more tries."
Case 6
    Debug.Print "Reflexes should tell you that it's hot!"
Case 7
    Debug.Print "You got hit!"
Case 8
    Debug.Print "That thing is mostly evil."
Case 9
    Debug.Print "There was an error..." & Err.Description
End Select
'#End If
'Shut down music
StopDXMusic
CloseDXMusic
Set GammaControler = Nothing
Set Effects = Nothing
Set Mainpic = Nothing
Set Tiler = Nothing
Set backbuffer = Nothing
Set ddClipper = Nothing
Set Mainsurf = Nothing
Set primary = Nothing
Set dd = Nothing
Set dx = Nothing
Set Boxset = Nothing
'Program is closed
MsgBox "Time:  " & DayClock & vbNewLine & "Score: " & Score
Unload Me

'If it's not closed, force it. :)
End
End Sub

Private Sub Form_Click()

'DirectDraw pre-testing
XCnt = XCnt + 1
'If XCnt = 1 Then InitSurfaces
'DrawBox - Left, Top, Left+Width, Top+Height
'If XCnt = 2 Then Mainsurf.DrawBox 10, 20, 200, 80
'DrawRoundedBox - Left, Top, Left+Width, Top+Height, RoundingWidth (on each side), (and) RoundingHeight (on each sides
'If XCnt = 3 Then Mainsurf.DrawRoundedBox 100, 100, 420, 140, 50, 10
'DrawCircle - OriginLeft, OriginTop, Radius
'If XCnt = 4 Then Mainsurf.DrawCircle 80, 180, 20
'DrawEllipse - Left, Top, Left+Width, Top+Height
'If XCnt = 5 Then Mainsurf.DrawEllipse 90, 210, 210, 280
'SetForeColor - tolongcolor
'If XCnt = 6 Then Mainsurf.SetForeColor 12336046
'DrawLine - HX, HY, TX, TY
'If XCnt = 7 Then Mainsurf.DrawLine 6, 27, 400, 378
'SetFillStyle - same as VBs control shape.fillstyle
'If XCnt = 8 Then
'    Mainsurf.SetFillStyle 0
'    Mainsurf.SetFillColor RGB(0, 120, 240)
'End If
'If XCnt = 9 Then Mainsurf.DrawBox 160, 300, 500, 360
'If XCnt = 10 Then
'    Dim FontInfo As New StdFont 'Note the use of "New" - This is very important.  Old fonts are garbage
'    backbuffer.SetFontTransparency True
'    backbuffer.SetForeColor RGB(0, 128, 0)
'    FontInfo.Bold = True
'    FontInfo.Size = 10
'    FontInfo.Name = "Courier"
'    backbuffer.SetFont FontInfo
    'drawtext - x , y , text , (append?)
'    Mainsurf.DrawText 0, 0, "I Love You!", False
'End If
'If XCnt = 11 Then Mainsurf.DrawText 0, 0, "You are Wonderful", True
'Clicking the form 12 times will result in the program closing down.
'because the form is maximised (and therefore covers the whole screen)
'where you click is not important.  This procedure will be removed along
'with the mouse upon completion
'Hmm... I haven't deleted this yet.
If XCnt = 12 Then EndIt 2
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
'T = CB' + B'C'(WX + YZ + A')
If DXMode > 0 Then Exit Sub
If bAutoKeyed = False Then Exit Sub
'Get out of the sub if there is some displaying going on.
Dim retval As Long, Sideleft As Boolean
Dim A As String, B As String
'Where I "A"m  , Where I wanna "B",

A = Map(Self.I, Self.J, MapID)  'Where I Am
    '***************
    'Key Left Code
    '***************
If KeyCode = 37 Then
    SDir = 0  'Direction is 0 - this will go into calculating the dynamic aspects of this game
    Self = LookVector2D(Self, LeftDir)
    'I go where I'm looking - this is only temporary though
    'Saves the "agony" of creating a temporary vector
        
    B = Map(Self.I, Self.J, MapID) 'What is this tile looking like where I am?
    If InBoxSet("Jump Boots", False) And CBool(InStr(1, ";{|}", B)) And Not CBool(OnSkiLift) Then
        Self = LookVector2D(Self, LeftDir)
        B = Map(Self.I, Self.J, MapID)  'This block of code is for the Jump Boots' ability to cross gaps.
    End If
    If Left$(B, 1) = "?" Then      'Extract the whole title unless I am reading a sign.
        ActString = Mid$(B, 2)
        DXMode = 5
    End If
    B = Left$(B, 1)
    If CBool(InStr(1, "BEHIKLMbehiklm", A, vbBinaryCompare)) Or Not (CBool(OnSkiLift) Or (Not CBool(OnSkiLift) And ((CBool(InStr(1, "2vwxy", B, vbBinaryCompare)) And InBoxSet("Raft", False)) Or (B = "/" And InBoxSet("Pass", False)) Or Not CBool(InStr(1, "1235DFHJKMNdfhjkmnt+,()*PRT/vwxy?""#_`", B, vbBinaryCompare))))) Then Self = LookVector2D(Self, RightDir): bWalk = False
    'This long boolean algebraic equation checks the following:
    'If there's a wall in front of me, I can't go forward, else if
    'there is a skilift in front of me I can get on and go forward regardless of the tile, else
    'if there is not a skilift but some water and I so happen to have a raft, then I can go
    'forward, else if there is a passgate and I so happen to have a pass ;), then I can go forward
    '(Passgate becomes plain grass after entry), or if the tile I am going to is just a
    'garden variety tile, then I can go forward.
    'Digital Logic.
           
    MapChecker B   'Procedure common to all key events
    '************
    'Key Up Procedure
    '************
ElseIf KeyCode = 38 Then    'Same as above keycode
    SDir = 1
    Self = LookVector2D(Self, UpDir)
    
    B = Map(Self.I, Self.J, MapID) 'What is this tile looking like where I am?
    If InBoxSet("Jump Boots", False) And CBool(InStr(1, ";{|}", B)) And Not CBool(OnSkiLift) Then
        Self = LookVector2D(Self, UpDir)
        B = Map(Self.I, Self.J, MapID)  'This block of code is for the Jump Boots' ability to cross gaps.
    End If
    If Left$(B, 1) = "?" Then
        ActString = Mid$(B, 2)
        DXMode = 5
    End If
    B = Left$(B, 1)
    
    If CBool(InStr(1, "AEFGKLNaefgkln", A, vbBinaryCompare)) Or Not (CBool(OnSkiLift) Or (Not CBool(OnSkiLift) And ((CBool(InStr(1, "2vwxy", B, vbBinaryCompare)) And InBoxSet("Raft", False)) Or (B = "/" And InBoxSet("Pass", False)) Or Not CBool(InStr(1, "1235CGIJLMNcgijlmnu+,()*PRT/vwxy?""#_`", B, vbBinaryCompare))))) Then Self = LookVector2D(Self, DownDir): bWalk = False
    'Only difference is the tiles that I can step on.
    'I can step on a 'up-access reject tile' (arrow pointing down) from the Left button
    'procedure, but not from the Up button
    
    MapChecker B    'Same deal-io
    '*********
    'Key Right Code
    '*********
ElseIf KeyCode = 39 Then
    SDir = 2
    Self = LookVector2D(Self, RightDir)
    
    B = Map(Self.I, Self.J, MapID) 'What is this tile looking like where I am?
    If InBoxSet("Jump Boots", False) And CBool(InStr(1, ";{|}", B)) And Not CBool(OnSkiLift) Then
        Self = LookVector2D(Self, RightDir)
        B = Map(Self.I, Self.J, MapID)  'This block of code is for the Jump Boots' ability to cross gaps.
    End If
    If Left$(B, 1) = "?" Then      'Extract the whole title unless I am reading a sign.
        ActString = Mid$(B, 2)
        DXMode = 5
    End If
    B = Left$(B, 1)
    
    If CBool(InStr(1, "DFHJKMNdfhjkmn", A, vbBinaryCompare)) Or Not (CBool(OnSkiLift) Or (Not CBool(OnSkiLift) And ((CBool(InStr(1, "2vwxy", B, vbBinaryCompare)) And InBoxSet("Raft", False)) Or (B = "/" And InBoxSet("Pass", False)) Or Not CBool(InStr(1, "1235BEHIKLMbehiklmr+,()*PRT/vwxy?""#_`", B, vbBinaryCompare))))) Then Self = LookVector2D(Self, LeftDir): bWalk = False
    
    MapChecker B
    '**************
    'Key Down Code
    '**************
ElseIf KeyCode = 40 Then
    SDir = 3
    Self = LookVector2D(Self, DownDir)
    
    B = Map(Self.I, Self.J, MapID) 'What is this tile looking like where I am?
    If InBoxSet("Jump Boots", False) And CBool(InStr(1, ";{|}", B)) And Not CBool(OnSkiLift) Then
        Self = LookVector2D(Self, DownDir)
        B = Map(Self.I, Self.J, MapID)  'This block of code is for the Jump Boots' ability to cross gaps.
    End If
    If Left$(B, 1) = "?" Then      'Extract the whole title unless I am reading a sign.
        ActString = Mid$(B, 2)
        DXMode = 5
    End If
    B = Left$(B, 1)
    
    If CBool(InStr(1, "CGIJLMNcgijlmn", A, vbBinaryCompare)) Or Not (CBool(OnSkiLift) Or (Not CBool(OnSkiLift) And ((CBool(InStr(1, "2vwxy", B, vbBinaryCompare)) And InBoxSet("Raft", False)) Or (B = "/" And InBoxSet("Pass", False)) Or Not CBool(InStr(1, "123AEFGKLNaefgklns+,()*PRT/vwxy?""#_`", B, vbBinaryCompare))))) Then Self = LookVector2D(Self, UpDir): bWalk = False
    'This one is shorter because of the cliffs that you are allowed to go "down".
    
    MapChecker B
ElseIf KeyCode = 73 Then
    'I press... use Freeze Beam
    If InBoxSet("Freeze Beam", False) Then
        For retval = 0 To 2
            With Projectile(retval)
                If .Activated = False Then
                    .Activated = True
                    .Direc = SDir
                    .L.I = Self.I
                    .L.J = Self.J
                    .L.K = MapID
                    .T = FreezeBeam
                    .UsedBySelf = True
                    retval = 2
                End If
            End With
        Next
    End If
ElseIf KeyCode = 75 Then
    'K press... use Shock Wave
    If InBoxSet("Shock Wave", False) Then
        For retval = 0 To 2
            With Projectile(retval)
                If .Activated = False Then
                    .Activated = True
                    .Direc = SDir
                    .L.I = Self.I
                    .L.J = Self.J
                    .L.K = MapID
                    .T = ShockWave
                    .UsedBySelf = True
                    retval = 2
                End If
            End With
        Next
    End If
ElseIf KeyCode = 74 Then
    'J press... use Extinguisher
    If InBoxSet("Extinguisher", False) Then
        For retval = 0 To 2
            With Projectile(retval)
                If .Activated = False Then
                    .Activated = True
                    .Direc = SDir
                    .L.I = Self.I
                    .L.J = Self.J
                    .L.K = MapID
                    .T = Extinguisher
                    .UsedBySelf = True
                    retval = 2
                End If
            End With
        Next
    End If
ElseIf KeyCode = 77 Then
    'M press... use Napalm
    If InBoxSet("Napalm", False) Then
        For retval = 0 To 2
            With Projectile(retval)
                If .Activated = False Then
                    .Activated = True
                    .Direc = SDir
                    .L.I = Self.I
                    .L.J = Self.J
                    .L.K = MapID
                    .T = Napalm
                    .UsedBySelf = True
                    retval = 2
                End If
            End With
        Next
    End If
End If


MoveStuff
RecalibrateLargeTile
bJustScrolled = False
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
Dim retval As Long, Sideleft As Boolean
Dim A As String, B As String
'Where I "A"m  , Where I wanna "B",
If KeyAscii > 96 Then KeyAscii = KeyAscii - 32
'Convert to uppercase KeyAscii.
If DXMode = 7 Then Exit Sub

A = Map(Self.I, Self.J, MapID)  'Where I Am

If KeyAscii = 81 Then  'Quit button - quit at anytime or if you are trapped (heh heh heh...)
    DXMode = 6
    primary.DrawRoundedBox 0, 464, 640, 480, 10, 2
    primary.DrawText 0, 464, "Do you want to quit? (Y/N/Retry)", False
    Sleep 10
ElseIf DXMode = 6 Then
    If KeyAscii = 78 Then
        DXMode = 0
    ElseIf KeyAscii = 89 Then
        EndIt 1
    ElseIf KeyAscii = 82 Then
        EndIt 5
    End If
ElseIf KeyAscii = 79 Then
    'Door toggling block
    
    Self = LookVector2D(Self, SDir)
    'I be wherefore I am... looking
    A = Toggle(Map(Self.I, Self.J, MapID), "+", "-")
    'If I happen to be on a door, the door will toggle.
    'I wrote a friendly function that toggles a string value into the opposite of the
    'input states
    
    'For doors with locks, we must check if the key is in the boxset (inventory) - if it is, the door opens easily - Pop'A'Lock not required :)
    If Map(Self.I, Self.J, MapID) = "(" Then If InBoxSet("Red Key", True) Then Map(Self.I, Self.J, MapID) = "-"
    If Map(Self.I, Self.J, MapID) = ")" Then If InBoxSet("Green Key", True) Then Map(Self.I, Self.J, MapID) = "-"
    If Map(Self.I, Self.J, MapID) = "*" Then If InBoxSet("Blue Key", True) Then Map(Self.I, Self.J, MapID) = "-"
    'Layered because of invalid check
    'Hear the doors opening/closing
    If Map(Self.I, Self.J, MapID) = "-" Then
        SetDXSound App.Path & "\dooropen.wav", 1
        PlayDXSound 1, DSBPLAY_DEFAULT
    ElseIf Map(Self.I, Self.J, MapID) = "+" Then
        SetDXSound App.Path & "\doorclose.wav", 1
        PlayDXSound 1, DSBPLAY_DEFAULT
    End If
    'Now, I move back to wherever I came from.
    Self = LookVector2D(Self, (SDir + 2) Mod 4)
ElseIf KeyAscii = 80 Then
    Debug.Print "Current position: " & Self.I & "," & Self.J & "," & MapID
    Beep
ElseIf KeyAscii = 83 Then
        SaveLoc.I = Self.I
        SaveLoc.J = Self.J
        SaveLoc.K = MapID
        SaveGrad.I = gmR
        SaveGrad.J = gmG
        SaveGrad.K = gmB
        DXMode = 5
        ActString = "Game was saved."
ElseIf KeyAscii = 76 Then
    'This lists the contents of your BoxSet with the L key
    'A much needed concept -- don't know why I haven't
    'implemented this before. :}

    If Self.I - LTile < 20 Then
        Sideleft = True
        primary.DrawBox 320, 0, 640, 480
        primary.DrawBox 0, 464, 320, 480
        primary.DrawText 0, 464, "Score: " & Score, False
    Else
        primary.DrawBox 0, 0, 320, 480
        primary.DrawBox 320, 464, 640, 480
        primary.DrawText 320, 464, "Score: " & Score, False
    End If
    'Draws the box on the opposite side of the screen from you. :)
    For retval = 1 To Boxset.Count
        If Sideleft Then
            primary.DrawText 320, retval * 16 - 16, Boxset.Item(retval), False
        Else
            primary.DrawText 0, retval * 16 - 16, Boxset.Item(retval), False
        End If
    Next

    DoEvents
    'show the info to you :}
    Sleep 2000
ElseIf KeyAscii = 68 Then
    For retval = 0 To 2
        Projectile(retval).Activated = False
    Next
ElseIf KeyAscii > 49 And KeyAscii <= 57 Then
    'Numerical keys control volume.
    SetDXVolume (KeyAscii - 48) * 10
ElseIf KeyAscii = 48 Then
    'Mute button -- 0
    'You could specify no music in main form...
    'this is for temporary silence... relatively :)
    SetDXVolume 0
ElseIf KeyAscii = 13 Then
    If InBoxSet("Administration Badge", False) Then
        Self = LookVector2D(Self, SDir)
        Map(Self.I, Self.J, MapID) = "%"
    End If
End If

End Sub

Private Sub Form_Load()

    SetUpDXMusic App.Path & "\adventure.mid"
    SetDXVolume 60
    SetupDXSound Me.hWnd, dx
Tries = 3
'Initialization of click counter.
Randomize
XCnt = 0
'Now the whole program is starting... ooh, ahh.

LastTog = 2    'RGB block toggle values - more info in Movestuff
SecTog = 1

'Music file.  Music along with maps need to be moved.
If Len(DestFile) = 0 Then
    DXMode = 5: ActString = "Initializa Plains"
'If there is no file to load...
    MapID = 0: MapPrev = 1
    'Start our game!
    'Startup position
    '10,80
    Self.I = 10: Self.J = 80
    SaveLoc.I = Self.I: SaveLoc.J = Self.J: SaveLoc.K = MapID
    LoadWorld
    DayClock = 0
    Boxset.Add "Jump Boots"
    Boxset.Add "Autumn Flag"
ElseIf Left$(DestFile, 1) <> "*" Then
'OK, there's an explanation for why I read the file in twice
'The first time is only for getting the measurements/locations
    ReadFromFile DestFile
'Now the game data is set
    LoadWorld
'and now the file data is placed on the map
'omitting one of these read files would either result in the measurements or the map data to be neglected.
    ReadFromFile DestFile
    SaveLoc.I = Self.I: SaveLoc.J = Self.J: SaveLoc.K = MapID
Else
    DXMode = 5: ActString = "Initializa Plains"
    DestFile = Mid$(DestFile, 2)
    MapID = 0: MapPrev = 1
    Self.I = 10: Self.J = 80
    SaveLoc.I = 10: SaveLoc.J = 80: SaveLoc.K = 0
    LoadWorld
    'Start our game!
    'Startup position
    '10,10
End If
'Debug testing for me. ;)
'This doesn't work - disregard



'Go into our shed and crank up DirectX
Init

'Errors to fix:
End Sub
Private Sub LoadWorld()
'Loop variables v & w,    'Input string   'Map NO. (number)  '2ndstring process sign/treasure data  'finds the end of the sign/treasure data, denoted by '@'
Dim v As Byte, w As Byte, z As String, Stri As String, MNO    As Integer, secondstring                As String, SecondEnd                                     As Integer
Dim LV As Integer, Preval As Boolean
LV = 0
StopDXMusic
wtFog = False
wtRain = False
wtAlert = False

Select Case MapID
Case 0 To 1
    ChangeDXMusicFile App.Path & "\adventure.mid"
    TileSet = 0
Case 2 To 9
    ChangeDXMusicFile App.Path & "\heights.mid"
    TileSet = 0
Case 10 To 15
    ChangeDXMusicFile App.Path & "\blizz.mid"
    TileSet = 1
Case 16 To 17
    ChangeDXMusicFile App.Path & "\blizz.mid"
    TileSet = 2
Case 18 To 21
    ChangeDXMusicFile App.Path & "\tunnel.mid"
    TileSet = 2
Case 22 To 31
    ChangeDXMusicFile App.Path & "\snow.mid"
    TileSet = 1
Case 32 To 39
    ChangeDXMusicFile App.Path & "\icebeach.mid"
    TileSet = 3
Case 40 To 48
    ChangeDXMusicFile App.Path & "\jungilis.mid"
    TileSet = 0
Case 49 To 63
    ChangeDXMusicFile App.Path & "\boutit~1.mid"
    TileSet = 1
Case 64 To 70
    ChangeDXMusicFile App.Path & "\rockma~1.mid"
    TileSet = 4
Case 71 To 76
    ChangeDXMusicFile App.Path & "\japja.mid"
    TileSet = 3
Case 77 To 82
    ChangeDXMusicFile App.Path & "\zerolith.mid"
    TileSet = 0
Case 83 To 94
    ChangeDXMusicFile App.Path & "\crforest.mid"
    TileSet = 4
Case 95 To 102
    ChangeDXMusicFile App.Path & "\basis.mid"
    TileSet = 2
Case 103 To 104
    ChangeDXMusicFile App.Path & "\adventure.mid"
    TileSet = 0
End Select
Do
OnRed(MNO) = False
OnGreen(MNO) = False
OnBlue(MNO) = False
'Initialization of colored blocks.
'Load our maps into our 3D array of characters/strings.

'Loads filename as a function of MNO. - using the Chr$ too.
If MNO >= 0 And MNO <= 1 Then Open App.Path & "\null3" & Chr$(65 + MNO) & ".qrl" For Input As #1            '2
If MNO >= 2 And MNO <= 9 Then Open App.Path & "\jusk" & Chr$(63 + MNO) & ".qrl" For Input As #1             '8
If MNO >= 10 And MNO <= 17 Then Open App.Path & "\grier" & Chr$(55 + MNO) & ".qrl" For Input As #1          '8
If MNO >= 18 And MNO <= 21 Then Open App.Path & "\walls" & Chr$(47 + MNO) & ".qrl" For Input As #1          '4
If MNO >= 22 And MNO <= 31 Then Open App.Path & "\noja" & Chr$(43 + MNO) & ".qrl" For Input As #1           '10
If MNO >= 32 And MNO <= 39 Then Open App.Path & "\hexa" & Chr$(33 + MNO) & ".qrl" For Input As #1           '8
If MNO >= 40 And MNO <= 48 Then Open App.Path & "\coin" & Chr$(25 + MNO) & ".qrl" For Input As #1           '9
If MNO >= 49 And MNO <= 63 Then Open App.Path & "\dbout" & Chr$(16 + MNO) & ".qrl" For Input As #1          '15
If MNO >= 64 And MNO <= 70 Then Open App.Path & "\bun" & Chr$(1 + MNO) & ".qrl" For Input As #1             '7
If MNO >= 71 And MNO <= 76 Then Open App.Path & "\hia" & Chr$(MNO - 6) & ".qrl" For Input As #1             '6
If MNO >= 77 And MNO <= 82 Then Open App.Path & "\cont" & Chr$(MNO - 12) & ".qrl" For Input As #1           '6
If MNO >= 83 And MNO <= 94 Then Open App.Path & "\nic" & Chr$(MNO - 18) & ".qrl" For Input As #1            '12
If MNO >= 95 And MNO <= 102 Then Open App.Path & "\cave" & Chr$(MNO - 30) & ".qrl" For Input As #1          '8
If MNO >= 103 And MNO <= 104 Then Open App.Path & "\sfg" & Chr$(MNO - 38) & ".qrl" For Input As #1          '2

    For v = 0 To BIGY - 1
        Line Input #1, Stri  'Get the line
        Debug.Assert Len(Stri) >= 110
        For w = 0 To BIGX - 1
            z = Mid$(Stri, w + 1, 1)
            Preval = CBool(z = "/" Or z = "!" Or z = "(" Or z = ")" Or z = "*")
            If binit = False Then
                Map(w, v, MNO) = z
                If Preval Then
                    DataPoints(LV).I = w
                    DataPoints(LV).J = v
                    DataPoints(LV).K = MNO
                    LV = LV + 1
                End If
            ElseIf Not Preval And z <> "?" Then
                Map(w, v, MNO) = z 'Inject into the map
'            Else
'                Stop
            End If
            If z = "?" Then    'Check for sign
                secondstring = Mid$(Stri, w + 2)
                SecondEnd = InStr(1, secondstring, "@", vbBinaryCompare)
                If binit = False Then Map(w, v, MNO) = "?" & Mid$(secondstring, 1, SecondEnd - 1)
                Stri = Left$(Stri, w) & "?" & Mid$(Stri, w + SecondEnd + 2)
                'Sign text goes into the tile as well.
                'I took this out forgetting that the sign actually has data in it... stupid me :)
            ElseIf z = "!" Then    'Check for treasure
                secondstring = Mid$(Stri, w + 2)
                SecondEnd = InStr(1, secondstring, "@", vbBinaryCompare)
                If binit = False Then Map(w, v, MNO) = "!" & Mid$(secondstring, 1, SecondEnd - 1)
                Stri = Left$(Stri, w) & "!" & Mid$(Stri, w + SecondEnd + 2)
                'Treasure contents go into the tile.
                'These will be recognized by finding the ! and ? as the first characters
            ElseIf z = ";" And v > 0 Then
                If Map(w, v - 1, MNO) = ";" Or Map(w, v - 1, MNO) = "{" Then Map(w, v, MNO) = "{"
            ElseIf z = "0" Then  'Automatic landscaping lines
                If Int(Rnd * 20) = 0 Then Map(w, v, MNO) = "6"
            End If
        Next
    Next
Close #1


Select Case MNO  'Initialize our RGB block states and windvalues.
Case 0
    Darkself(0).L = SetVector3D(61, 79, MNO)
    Darkself(0).Activated = True
    Darkself(0).Throws = ShockWave
Case 5
    Darkself(1).L = SetVector3D(61, 16, MNO)
    Darkself(1).Activated = True
    Darkself(1).Throws = ShockWave
Case 17
    Darkself(2).L = SetVector3D(54, 40, MNO)
    Darkself(2).Activated = True
    Darkself(2).Throws = ShockWave
    Darkself(3).L = SetVector3D(53, 41, MNO)
    Darkself(3).Activated = True
    Darkself(3).Throws = ShockWave
    Darkself(4).L = SetVector3D(52, 42, MNO)
    Darkself(4).Activated = True
    Darkself(4).Throws = ShockWave
    Darkself(5).L = SetVector3D(51, 43, MNO)
    Darkself(5).Activated = True
    Darkself(5).Throws = ShockWave
    Darkself(6).L = SetVector3D(50, 44, MNO)
    Darkself(6).Activated = True
    Darkself(6).Throws = ShockWave
    Darkself(7).L = SetVector3D(37, 53, MNO)
    Darkself(7).Activated = True
    Darkself(7).Throws = ShockWave
    Darkself(8).L = SetVector3D(43, 60, MNO)
    Darkself(8).Activated = True
    Darkself(8).Throws = ShockWave
    Darkself(9).L = SetVector3D(21, 63, MNO)
    Darkself(9).Activated = True
    Darkself(9).Throws = ShockWave
    Darkself(9).IntelligenceInt = 1
    Darkself(10).L = SetVector3D(11, 61, MNO)
    Darkself(10).Activated = True
    Darkself(10).Throws = ShockWave
Case 18
    Darkself(11).L = SetVector3D(1, 29, MNO)
    Darkself(11).Activated = True
    Darkself(11).Throws = ShockWave
    Darkself(12).L = SetVector3D(2, 30, MNO)
    Darkself(12).Activated = True
    Darkself(12).Throws = ShockWave
    Darkself(13).L = SetVector3D(21, 40, MNO)
    Darkself(13).Activated = True
    Darkself(13).Throws = ShockWave
    Darkself(14).L = SetVector3D(7, 87, MNO)
    Darkself(14).Activated = True
    Darkself(14).Throws = ShockWave
    Darkself(14).IntelligenceInt = 1
    Darkself(15).L = SetVector3D(48, 85, MNO)
    Darkself(15).Activated = True
    Darkself(15).Throws = ShockWave
    Darkself(16).L = SetVector3D(53, 84, MNO)
    Darkself(16).Activated = True
    Darkself(16).Throws = ShockWave
    Darkself(17).L = SetVector3D(58, 83, MNO)
    Darkself(17).Activated = True
    Darkself(17).Throws = ShockWave
Case 19
    Darkself(18).L = SetVector3D(117, 9, MNO)
    Darkself(18).Activated = True
    Darkself(18).Throws = ShockWave
    Darkself(19).L = SetVector3D(88, 29, MNO)
    Darkself(19).Activated = True
    Darkself(19).Throws = ShockWave
    Darkself(20).L = SetVector3D(85, 12, MNO)
    Darkself(20).Activated = True
    Darkself(20).Throws = ShockWave
    Darkself(21).L = SetVector3D(84, 10, MNO)
    Darkself(21).Activated = True
    Darkself(21).Throws = ShockWave
    Darkself(22).L = SetVector3D(7, 46, MNO)
    Darkself(22).Activated = True
    Darkself(22).Throws = Napalm
    Darkself(23).L = SetVector3D(19, 44, MNO)
    Darkself(23).Activated = True
    Darkself(23).Throws = ShockWave
Case 20
    Darkself(24).L = SetVector3D(101, 42, MNO)
    Darkself(24).Activated = True
    Darkself(24).Throws = ShockWave
    Darkself(25).L = SetVector3D(77, 43, MNO)
    Darkself(25).Activated = True
    Darkself(25).Throws = ShockWave
Case 21
    Darkself(26).L = SetVector3D(98, 42, MNO)
    Darkself(26).Activated = True
    Darkself(26).Throws = Napalm
    Darkself(26).IntelligenceInt = 1
    Darkself(27).L = SetVector3D(82, 43, MNO)
    Darkself(27).Activated = True
    Darkself(27).Throws = Napalm
    Darkself(27).IntelligenceInt = 1
Case 34
    Darkself(28).L = SetVector3D(23, 38, MNO)
    Darkself(28).Activated = True
    Darkself(28).Throws = ShockWave
    Darkself(28).IntelligenceInt = 1
Case 39
    Darkself(29).L = SetVector3D(33, 39, MNO)
    Darkself(29).Activated = True
    Darkself(29).Throws = ShockWave
    Darkself(30).L = SetVector3D(71, 14, MNO)
    Darkself(30).Activated = True
    Darkself(30).Throws = ShockWave
Case 42
    Darkself(31).L = SetVector3D(20, 55, MNO)
    Darkself(31).Activated = True
    Darkself(31).Throws = ShockWave
Case 43
    Darkself(32).L = SetVector3D(17, 88, MNO)
    Darkself(32).Activated = True
    Darkself(32).Throws = ShockWave
Case 44
    Darkself(33).L = SetVector3D(21, 7, MNO)
    Darkself(33).Activated = True
    Darkself(33).Throws = ShockWave
    Darkself(34).L = SetVector3D(21, 85, MNO)
    Darkself(34).Activated = True
    Darkself(34).Throws = Napalm
    Darkself(35).L = SetVector3D(61, 88, MNO)
    Darkself(35).Activated = True
    Darkself(35).Throws = Extinguisher
    Darkself(36).L = SetVector3D(60, 86, MNO)
    Darkself(36).Activated = True
    Darkself(36).Throws = ShockWave
Case 45
    Darkself(37).L = SetVector3D(106, 40, MNO)
    Darkself(37).Activated = True
    Darkself(37).Throws = Extinguisher
Case 46
    Darkself(38).L = SetVector3D(37, 28, MNO)
    Darkself(38).Activated = True
    Darkself(38).Throws = Extinguisher
    Darkself(39).L = SetVector3D(34, 28, MNO)
    Darkself(39).Activated = True
    Darkself(39).Throws = ShockWave
Case 47
    Darkself(40).L = SetVector3D(15, 11, MNO)
    Darkself(40).Activated = True
    Darkself(40).Throws = Extinguisher
    Darkself(41).L = SetVector3D(83, 54, MNO)
    Darkself(41).Activated = True
    Darkself(41).Throws = ShockWave
    Darkself(42).L = SetVector3D(59, 59, MNO)
    Darkself(42).Activated = True
    Darkself(42).Throws = Napalm
    Darkself(43).L = SetVector3D(74, 57, MNO)
    Darkself(43).Activated = True
    Darkself(43).Throws = Napalm
    Darkself(44).L = SetVector3D(75, 44, MNO)
    Darkself(44).Activated = True
    Darkself(44).Throws = Napalm
    Darkself(45).L = SetVector3D(82, 8, MNO)
    Darkself(45).Activated = True
    Darkself(45).Throws = ShockWave
Case 54
    Darkself(46).L = SetVector3D(58, 51, MNO)
    Darkself(46).Activated = True
    Darkself(46).Throws = ShockWave
    Darkself(47).L = SetVector3D(59, 36, MNO)
    Darkself(47).Activated = True
    Darkself(47).Throws = ShockWave
    Darkself(48).L = SetVector3D(60, 42, MNO)
    Darkself(48).Activated = True
    Darkself(48).Throws = ShockWave
Case 56
    Darkself(49).L = SetVector3D(29, 77, MNO)
    Darkself(49).Activated = True
    Darkself(49).Throws = Napalm
    Darkself(50).L = SetVector3D(73, 79, MNO)
    Darkself(50).Activated = True
    Darkself(50).Throws = Napalm
Case 60
    Darkself(51).L = SetVector3D(87, 25, MNO)
    Darkself(51).Activated = True
    Darkself(51).Throws = ShockWave
    Darkself(52).L = SetVector3D(111, 24, MNO)
    Darkself(52).Activated = True
    Darkself(52).Throws = ShockWave
    Darkself(52).IntelligenceInt = 2
Case 61
    Darkself(53).L = SetVector3D(47, 30, MNO)
    Darkself(53).Activated = True
    Darkself(53).Throws = FreezeBeam
    Darkself(54).L = SetVector3D(90, 4, MNO)
    Darkself(54).Activated = True
    Darkself(54).Throws = ShockWave
    Darkself(55).L = SetVector3D(95, 3, MNO)
    Darkself(55).Activated = True
    Darkself(55).Throws = ShockWave
    Darkself(56).L = SetVector3D(100, 2, MNO)
    Darkself(56).Activated = True
    Darkself(56).Throws = ShockWave
    Darkself(57).L = SetVector3D(104, 1, MNO)
    Darkself(57).Activated = True
    Darkself(57).Throws = ShockWave
Case 62
    Darkself(58).L = SetVector3D(45, 22, MNO)
    Darkself(58).Activated = True
    Darkself(58).Throws = Napalm
    Darkself(59).L = SetVector3D(45, 30, MNO)
    Darkself(59).Activated = True
    Darkself(59).Throws = Napalm
    Darkself(60).L = SetVector3D(72, 27, MNO)
    Darkself(60).Activated = True
    Darkself(60).Throws = FreezeBeam
    Darkself(60).IntelligenceInt = 1
    Darkself(61).L = SetVector3D(66, 23, MNO)
    Darkself(61).Activated = True
    Darkself(61).Throws = FreezeBeam
    Darkself(61).IntelligenceInt = 2
Case 63
    Darkself(62).L = SetVector3D(36, 33, MNO)
    Darkself(62).Activated = True
    Darkself(62).Throws = ShockWave
    Darkself(63).L = SetVector3D(83, 30, MNO)
    Darkself(63).Activated = True
    Darkself(63).Throws = ShockWave
    Darkself(63).IntelligenceInt = 2
    Darkself(64).L = SetVector3D(72, 23, MNO)
    Darkself(64).Activated = True
    Darkself(64).Throws = ShockWave
    Darkself(64).IntelligenceInt = 2
Case 65
    Darkself(65).L = SetVector3D(77, 25, MNO)
    Darkself(65).Activated = True
    Darkself(65).Throws = ShockWave
    Darkself(65).IntelligenceInt = 1
Case 66
    Darkself(66).L = SetVector3D(105, 58, MNO)
    Darkself(66).Activated = True
    Darkself(66).Throws = ShockWave
    Darkself(66).IntelligenceInt = 2
Case 67
    Darkself(67).L = SetVector3D(17, 48, MNO)
    Darkself(67).Activated = True
    Darkself(67).Throws = ShockWave
    Darkself(68).L = SetVector3D(38, 48, MNO)
    Darkself(68).Activated = True
    Darkself(68).Throws = ShockWave
    Darkself(69).L = SetVector3D(101, 44, MNO)
    Darkself(69).Activated = True
    Darkself(69).Throws = ShockWave
Case 68
    Darkself(70).L = SetVector3D(14, 35, MNO)
    Darkself(70).Activated = True
    Darkself(70).Throws = ShockWave
    Darkself(71).L = SetVector3D(32, 53, MNO)
    Darkself(71).Activated = True
    Darkself(71).Throws = Extinguisher
    Darkself(71).IntelligenceInt = 2
    Darkself(72).L = SetVector3D(45, 15, MNO)
    Darkself(72).Activated = True
    Darkself(72).Throws = ShockWave
Case 69
    Darkself(73).L = SetVector3D(97, 82, MNO)
    Darkself(73).Activated = True
    Darkself(73).Throws = Napalm
    Darkself(73).IntelligenceInt = 2
Case 70
    Darkself(74).L = SetVector3D(35, 77, MNO)
    Darkself(74).Activated = True
    Darkself(74).Throws = Napalm
    Darkself(74).IntelligenceInt = 2
    Darkself(75).L = SetVector3D(52, 46, MNO)
    Darkself(75).Activated = True
    Darkself(75).Throws = Extinguisher
    Darkself(75).IntelligenceInt = 2
Case 71
    Darkself(76).L = SetVector3D(72, 63, MNO)
    Darkself(76).Activated = True
    Darkself(76).Throws = ShockWave
Case 72
    Darkself(77).L = SetVector3D(8, 73, MNO)
    Darkself(77).Activated = True
    Darkself(77).Throws = ShockWave
    Darkself(78).L = SetVector3D(18, 80, MNO)
    Darkself(78).Activated = True
    Darkself(78).Throws = ShockWave
Case 73
    OnBlue(MNO) = True
    Darkself(79).L = SetVector3D(72, 67, MNO)
    Darkself(79).Activated = True
    Darkself(79).Throws = ShockWave
Case 74
    Darkself(80).L = SetVector3D(63, 65, MNO)
    Darkself(80).Activated = True
    Darkself(80).Throws = ShockWave
    Darkself(80).IntelligenceInt = 1
Case 75
    Darkself(81).L = SetVector3D(51, 4, MNO)
    Darkself(81).Activated = True
    Darkself(81).Throws = ShockWave
Case 76
    Darkself(82).L = SetVector3D(69, 16, MNO)
    Darkself(82).Activated = True
    Darkself(82).Throws = ShockWave
    Darkself(82).IntelligenceInt = 2
Case 77
    Darkself(83).L = SetVector3D(1, 2, MNO)
    Darkself(83).Activated = True
    Darkself(83).Throws = Extinguisher
    Darkself(83).IntelligenceInt = 3
    Darkself(84).L = SetVector3D(30, 31, MNO)
    Darkself(84).Activated = True
    Darkself(84).Throws = Napalm
    Darkself(84).IntelligenceInt = 3
    Darkself(85).L = SetVector3D(2, 86, MNO)
    Darkself(85).Activated = True
    Darkself(85).Throws = Extinguisher
    Darkself(85).IntelligenceInt = 3
Case 78
    Darkself(86).L = SetVector3D(28, 69, MNO)
    Darkself(86).Activated = True
    Darkself(86).Throws = ShockWave
    Darkself(86).IntelligenceInt = 3
    Darkself(87).L = SetVector3D(114, 43, MNO)
    Darkself(87).Activated = True
    Darkself(87).Throws = Extinguisher
    Darkself(87).IntelligenceInt = 2
Case 79
    Darkself(88).L = SetVector3D(6, 88, MNO)
    Darkself(88).Activated = True
    Darkself(88).Throws = ShockWave
    Darkself(88).IntelligenceInt = 3
    Darkself(89).L = SetVector3D(24, 67, MNO)
    Darkself(89).Activated = True
    Darkself(89).Throws = ShockWave
    Darkself(89).IntelligenceInt = 2
    Darkself(90).L = SetVector3D(26, 23, MNO)
    Darkself(90).Activated = True
    Darkself(90).Throws = Napalm
    Darkself(90).IntelligenceInt = 3
    Darkself(91).L = SetVector3D(66, 87, MNO)
    Darkself(91).Activated = True
    Darkself(91).Throws = FreezeBeam
    Darkself(91).IntelligenceInt = 4
    Darkself(92).L = SetVector3D(108, 46, MNO)
    Darkself(92).Activated = True
    Darkself(92).Throws = ShockWave
    Darkself(92).IntelligenceInt = 3
    Darkself(93).L = SetVector3D(90, 55, MNO)
    Darkself(93).Activated = True
    Darkself(93).Throws = ShockWave
    Darkself(93).IntelligenceInt = 3
Case 80
    Darkself(94).L = SetVector3D(6, 80, MNO)
    Darkself(94).Activated = True
    Darkself(94).Throws = ShockWave
    Darkself(94).IntelligenceInt = 3
    Darkself(95).L = SetVector3D(101, 51, MNO)
    Darkself(95).Activated = True
    Darkself(95).Throws = Extinguisher
    Darkself(95).IntelligenceInt = 2
    Darkself(96).L = SetVector3D(59, 73, MNO)
    Darkself(96).Activated = True
    Darkself(96).Throws = ShockWave
    Darkself(96).IntelligenceInt = 3
    Darkself(97).L = SetVector3D(38, 55, MNO)
    Darkself(97).Activated = True
    Darkself(97).Throws = ShockWave
    Darkself(97).IntelligenceInt = 2
Case 81
    Darkself(98).L = SetVector3D(56, 68, MNO)
    Darkself(98).Activated = True
    Darkself(98).Throws = ShockWave
    Darkself(98).IntelligenceInt = 3
    Darkself(99).L = SetVector3D(104, 82, MNO)
    Darkself(99).Activated = True
    Darkself(99).Throws = FreezeBeam
    Darkself(100).L = SetVector3D(67, 8, MNO)
    Darkself(100).Activated = True
    Darkself(100).Throws = ShockWave
    Darkself(100).IntelligenceInt = 1
Case 82
    Darkself(101).L = SetVector3D(25, 86, MNO)
    Darkself(101).Activated = True
    Darkself(101).Throws = ShockWave
Case 95
    Darkself(102).L = SetVector3D(89, 6, MNO)
    Darkself(102).Activated = True
    Darkself(102).Throws = ShockWave
    Darkself(102).IntelligenceInt = 0
Case 98
    Darkself(103).L = SetVector3D(53, 65, MNO)
    Darkself(103).Activated = True
    Darkself(103).Throws = ShockWave
    Darkself(103).IntelligenceInt = 4
Case 99
    Darkself(104).L = SetVector3D(60, 71, MNO)
    Darkself(104).Activated = True
    Darkself(104).Throws = ShockWave
    Darkself(104).IntelligenceInt = 4
Case 100
    Darkself(105).L = SetVector3D(31, 40, MNO)
    Darkself(105).Activated = True
    Darkself(105).Throws = ShockWave
    Darkself(105).IntelligenceInt = 0
Case 103
    Darkself(106).L = SetVector3D(57, 68, MNO)
    Darkself(106).Activated = True
    Darkself(106).Throws = ShockWave
    Darkself(106).IntelligenceInt = 4
    Darkself(107).L = SetVector3D(76, 50, MNO)
    Darkself(107).Activated = True
    Darkself(107).Throws = Napalm
    Darkself(107).IntelligenceInt = 4
    
'    WindValue(MNO, 0) = 36
'Case 48
'    WindValue(MNO, 0) = 27
'    WindValue(MNO, 1) = 32
'Case 80
'    WindValue(MNO, 0) = 17
'Case 81, 82, 83
'    WindValue(MNO, 0) = 18
'    WindValue(MNO, 1) = 21
'Case 85
'    OnBlue(MNO) = True
'Case 128
'    WindValue(MNO, 0) = 14
'Case 162
'    WindValue(MNO, 0) = 27
'Case 168
'    WindValue(MNO, 0) = 20
'Case 171
'    WindValue(MNO, 0) = 22
'Case 174
'    WindValue(MNO, 0) = 14
'Case 191
'    WindValue(MNO, 0) = 10
'    WindValue(MNO, 1) = 19
'    WindValue(MNO, 2) = 26
'Case 198
'    WindValue(MNO, 0) = 12
'Case 245
'    WindValue(MNO, 0) = 8
'Case 255
'    WindValue(MNO, 0) = 1
'Case 257
'    WindValue(MNO, 0) = 30
'Case 258
'    WindValue(MNO, 0) = 33
'Case 259
'    WindValue(MNO, 0) = 11
'    WindValue(MNO, 1) = 23
'    WindValue(MNO, 2) = 34
End Select

MNO = MNO + 1
Loop Until MNO = MAPMAX + 1
If binit = False Then DPointCount = LV
'last time that I checked, DPointCount was 275
LoopRepeatDXMusic -1

PlayDXMusic
RecalibrateLargeTile

End Sub

Private Sub Form_Paint()
'If windows sends a "paint" message translate this into a call
'to DirectDraw.
blt
End Sub


Function ExModeActive() As Boolean
'This is used to test if we're in the correct resolution.
Dim TestCoopRes As Long
TestCoopRes = dd.TestCooperativeLevel
If TestCoopRes = DD_OK Then
ExModeActive = True
Else
ExModeActive = False
End If
End Function
Public Function GetAdapterInfo(ByRef Name As String, ByRef GUID As String)
'Adapter stuff
Dim Info As DirectDrawIdentifier
Set Info = dd.GetDeviceIdentifier(DDGDI_DEFAULT)
Name = Info.GetDescription
GUID = Info.GetDeviceIndentifier
End Function

Private Sub RenderMap(NumTilesX As Integer, NumTilesY As Integer, TileWidth As Integer, TileHeight As Integer, TileSourcesurf As DirectDrawSurface7, TileDestSurf As DirectDrawSurface7)
Dim X As Integer, Y As Integer, r As RECT, v As RECT, s As RECT, bs As RECT, retval As Long
Dim rX As Integer, rY As Integer
Dim pict() As Byte, rLock As RECT, ddsdL As DDSURFACEDESC2
Dim XOff As Integer, YOff As Integer
If DXMode = 1 Then XOff = PosFilter(5 - CountVar): YOff = 0
If DXMode = 3 Then XOff = NegFilter(CountVar - 5): YOff = 0
If DXMode = 2 Then YOff = PosFilter(5 - CountVar): XOff = 0
If DXMode = 4 Then YOff = NegFilter(CountVar - 5): XOff = 0
'These X and Y values are defining A MAP spot where we will blt to the surface.
For rX = XOff + LTile - 1 To NumTilesX + XOff + LTile
'OK.  XOff is the offset caused by the scrolling of the map tiles
'LTile is the offset causes by the intramap scrolling in the 120x90 mode.
'NumTiles is the number of tiles currently being displayed on the map
'It would usually be subtracted by one but since we are blitting off of the screen for
'scrolling, there are no ones in the second side
    For rY = YOff + TTile - 1 To NumTilesY + YOff + TTile
        X = rX
        Y = rY
    'Same here
        'Create our Rectangle depending on our conditions.
        If DXMode = 0 Then
            r.Left = 16 * Asc(Map(PosFilter(NegFilter(X) - (BIGX - 1)) + (BIGX - 1), PosFilter(NegFilter(Y) - (BIGY - 1)) + (BIGY - 1), MapID))
        ElseIf DXMode = 3 Then   'move to the east map
            If Y < 0 Then
                Y = 0
            ElseIf Y >= BIGY Then
                Y = BIGY - 1
            End If
            If X >= BIGX Then
                r.Left = 16 * Asc(Map(X - BIGX, Y, MapID))
            Else
                r.Left = 16 * Asc(Map(X, Y, MapPrev))
            End If
        ElseIf DXMode = 4 Then   'move to the south map
            If X < 0 Then
                X = 0
            ElseIf X >= BIGX Then
                X = BIGX - 1
            End If
            If Y >= BIGY Then
                r.Left = 16 * Asc(Map(X, Y - BIGY, MapID))
            Else
                r.Left = 16 * Asc(Map(X, Y, MapPrev))
            End If
        ElseIf DXMode = 1 Then 'to west map
            If Y < 0 Then
                Y = 0
            ElseIf Y >= BIGY Then
                Y = BIGY - 1
            End If
            If X >= 0 Then
                r.Left = 16 * Asc(Map(X, Y, MapPrev))
            Else
                r.Left = 16 * Asc(Map(BIGX + X, Y, MapID))
            End If
        ElseIf DXMode = 2 Then ' to north map
            If X < 0 Then
                X = 0
            ElseIf X >= BIGX Then
                X = BIGX - 1
            End If
            If Y >= 0 Then
                r.Left = 16 * Asc(Map(X, Y, MapPrev))
            Else
                r.Left = 16 * Asc(Map(X, BIGY + Y, MapID))
            End If
        End If
        r.Top = 16 * TileSet
        r.Right = r.Left + TileWidth
        r.Bottom = 16 * TileSet + 16
        'This is where we copy the tile from the source to the destination
        retval = TileDestSurf.BltFast(Int((X - XOff - LTile + 1) * TileWidth), Int((Y - YOff - TTile + 1) * TileHeight), TileSourcesurf, r, DDBLTFAST_WAIT)
    Next rY
Next rX
If DXMode = 0 Or DXMode = 5 Then
'This is basically a block to make sure that we don't redraw the lifts, beasts, or fighters when scrolling
    s.Left = 16
    s.Top = 16 * TileSet
    s.Right = 32
    s.Bottom = 16 * (1 + TileSet)
    retval = TileDestSurf.BltFast((Skilift.I - LTile + 1) * 16, (Skilift.J - TTile + 1) * TileHeight, TileSourcesurf, s, DDBLTFAST_WAIT)
    retval = TileDestSurf.BltFast((Skilift2.I - LTile + 1) * 16, (Skilift2.J - TTile + 1) * TileHeight, TileSourcesurf, s, DDBLTFAST_WAIT)
    bs = s
    bs.Left = 32
    bs.Right = 48
    For X = 0 To 4
        retval = TileDestSurf.BltFast((Beast(X).I - LTile + 1) * 16, (Beast(X).J - TTile + 1) * TileHeight, TileSourcesurf, bs, DDBLTFAST_WAIT)
    Next
    For X = 0 To UBound(Darkself)
        With Darkself(X)
            If .Activated And MapID = .L.K Then
                v.Left = .Direc * 16
                v.Top = 16
                v.Right = v.Left + 16
                v.Bottom = 32
                retval = TileDestSurf.BltFast(TileWidth * (.L.I - LTile + 1), TileHeight * (.L.J - TTile + 1), Mainpic, v, DDBLTFAST_SRCCOLORKEY)
            ElseIf .L.K > MapID Then
                X = UBound(Darkself)
                'None of them would be here since they're in order.
            End If
        End With
    Next
End If
v.Left = SDir * 16
v.Top = 0
v.Right = v.Left + 16
v.Bottom = 16
'Player Scrolling check
Dim Mvx As Long, Mvy As Long
If bWalk Then
    Select Case SDir
    Case Direction.LeftDir
        Mvx = 16 - Walktick
    Case Direction.UpDir
        Mvy = 16 - Walktick
    Case Direction.RightDir
        Mvx = Walktick - 16
    Case Direction.DownDir
        Mvy = Walktick - 16
    End Select
End If
retval = TileDestSurf.BltFast((Self.I - XOff - LTile + 1) * TileWidth + Mvx, (Self.J - XOff - TTile + 1) * TileHeight + Mvy, Mainpic, v, DDBLTFAST_SRCCOLORKEY)
For X = 0 To 4
    If Explosion(X).K > 0 Then
        v.Left = 48 * Int(Explosion(X).K - 1)
        v.Bottom = 48
        'v.Top is already set... I'll set it again, though.
        v.Top = 0
        v.Right = v.Left + 48
        retval = TileDestSurf.BltFast(TileWidth * (Explosion(X).I - LTile), TileHeight * (Explosion(X).J - TTile), Effects, v, DDBLTFAST_SRCCOLORKEY)
        'There is already a negative 1 here, so adding a positive 1 for the map offset merely causes the numbers to cancel.
        If Explosion(X).K = 8 Then Explosion(X).K = 0 Else Explosion(X).K = Explosion(X).K + 0.125
        'The 0.125 is convert into an integer in the BltFast, so it basically slows the explosion down to 1 / 0.125 or
        '8 ticks per frame
    End If
Next
For X = 0 To UBound(Projectile)
    If Projectile(X).Activated And Projectile(X).L.K = MapID Then
        v.Left = 384
        v.Top = Projectile(X).T * 16
        v.Right = 400
        v.Bottom = v.Top + 16
        retval = TileDestSurf.BltFast(TileWidth * (Projectile(X).L.I - LTile + 1), TileHeight * (Projectile(X).L.J - TTile + 1), Effects, v, DDBLTFAST_SRCCOLORKEY)
    End If
Next
'For X = 0 To UBound(Darkself)
'    With Darkself(X)
'        If .Activated And MapID = .L.K Then
'            v.Left = .Direc * 16
'            v.Top = 16
'            v.Right = v.Left + 16
'            v.Bottom = 32
'            retval = TileDestSurf.BltFast(TileWidth * (.L.I - LTile + 1), TileHeight * (.L.J - TTile + 1), Mainpic, v, DDBLTFAST_SRCCOLORKEY)
'        ElseIf .L.K > MapID Then
'            X = UBound(Darkself)
'            'None of them would be here since they're in order.
'        End If
'    End With
'Next
If wtFog Then
'    rLock.Top = 0
'    rLock.Left = 0
'    rLock.Bottom = 480
'    rLock.Right = 640
'    TileDestSurf.Lock rLock, ddsdL, DDLOCK_WAIT, 0
'    TileDestSurf.GetLockedArray pict
'    Weather.CreateFog pict, (Self.I + 0.5) * 16, (Self.I + 0.5) * 16, 100
'    TileDestSurf.Unlock rLock
    SetGamma 50 + Int(20 * HexagonWave(DayClock / 76)), 50 + Int(20 * HexagonWave(DayClock / 76)), 50 + Int(20 * HexagonWave(DayClock / 76))
ElseIf wtRain Then
'    rLock.Top = 0
'    rLock.Left = 0
'    rLock.Bottom = 480
'    rLock.Right = 640
'    TileDestSurf.Lock rLock, ddsdL, DDLOCK_WAIT, 0
'    TileDestSurf.GetLockedArray pict
'    Weather.CreateHaze pict, 3
'    TileDestSurf.Unlock rLock
'       This actually worked pretty good... except the framerate was a bit slower than 30 :-\.
'   /me stomps in rage
    SetGamma -70 + Int(60 * PulseishWave(DayClock / 66, 5)), -70 + Int(60 * PulseishWave(DayClock / 66, 5)), -70 + Int(60 * PulseishWave(DayClock / 66, 5))
ElseIf wtAlert Then
'This is the only one that worked as originally intended.
    SetGamma 20 + Int(50 * TriangleWave(DayClock / 43)), gmG, gmB
End If

End Sub
Private Sub PPrompt()
If DXMode = 5 Then
    With primary
        .SetFillStyle 0
        .SetFillColor 0
        .SetForeColor &HFFFFFF
        .DrawBox 0, 464, 600, 480
        .SetFontTransparency True
        .DrawText 0, 464, ActString, False
    End With
    DXMode = 0
    Sleep 1000
    If (wtAlert Or wtRain Or wtFog) = False Then SetGamma gmR, gmG, gmB
End If
End Sub
Private Sub MoveStuff()
Dim Junk As Boolean
If Self.I = BIGX - 1 Then   'Move right
    bJustScrolled = True
    DXMode = 3
    CounterOn = True
    Me.Enabled = False
    Self.I = 1
    Select Case MapID
    Case 2 To 8
        MapPrev = MapID: MapID = MapID + 1
        ActString = "Jusk Hills Zone"
    Case 10 To 13
        MapPrev = MapID: MapID = MapID + 2
        ActString = "Port Grier"
    Case 22, 26
        MapPrev = MapID: MapID = MapID + 1
        ActString = "Njabroq Mountain"
    Case 23, 27, 28
        MapPrev = MapID: MapID = MapID + 2
        ActString = "Njabroq Mountain"
    Case 33, 34, 38, 39
        MapPrev = MapID: MapID = MapID - 1
        ActString = "Hexadiemme Lake"
    Case 36
        MapPrev = 36: MapID = 34
        ActString = "Hexadiemme Lake"
    Case 41 To 48
        MapPrev = MapID: MapID = MapID + 2
        ActString = "Coineque di Pyreth Swamp"
    Case 49 To 63
        MapPrev = MapID: MapID = MapID + 1
        ActString = "D'boutit Peaks"
    Case 64 To 70
        MapPrev = MapID: MapID = MapID + 1
        ActString = "Bundirec Grassland"
    Case 71 To 76
        MapPrev = MapID: MapID = MapID + 1
        ActString = "Hiacojira Town"
    Case 77 To 82
        MapPrev = MapID: MapID = MapID + 1
        ActString = "Contraband Farms"
    Case 95 To 100
        MapPrev = MapID: MapID = MapID + 1
        ActString = "Amazing Cavern"
    Case 101, 102
        ActString = "Amazing Cavern"
    End Select  'Move right
    Do
        If CounterOn Then CountVar = CountVar + 1
        RenderMap 40, 30, 16, 16, Tiler, Mainsurf
        blt
        If CountVar >= 45 Then DXMode = 5: CountVar = 5: CounterOn = False: Me.Enabled = True
        bScroll = False
        DoEvents
    Loop Until CounterOn = False
ElseIf Self.I = 0 Then
    bJustScrolled = True
    DXMode = 1
    CounterOn = True
    Me.Enabled = False
    Self.I = 118
    Select Case MapID
    Case 3 To 9
        MapPrev = MapID: MapID = MapID - 1
        ActString = "Jusk Hills Zone"
    Case 12 To 15
        MapPrev = MapID: MapID = MapID - 2
        ActString = "Port Grier"
    Case 23, 27
        MapPrev = MapID: MapID = MapID - 1
        ActString = "Njabroq Mountain"
    Case 25, 29, 30
        MapPrev = MapID: MapID = MapID - 2
        ActString = "Njabroq Mountain"
    Case 32, 33, 37, 38
        MapPrev = MapID: MapID = MapID + 1
        ActString = "Hexadiemme Lake"
    Case 34
        MapPrev = MapID: MapID = 36
        ActString = "Hexadiemme Lake"
    Case 43 To 48
        MapPrev = MapID: MapID = MapID - 2
        ActString = "Coineque di Pyreth Swamp"
    Case 49 To 63
        MapPrev = MapID: MapID = MapID - 1
        ActString = "D'boutit Peaks"
    Case 64 To 70
        MapPrev = MapID: MapID = MapID - 1
        ActString = "Bundirec Grassland"
    Case 71 To 76
        MapPrev = MapID: MapID = MapID - 1
        ActString = "Hiacojira Town"
    Case 77 To 82
        MapPrev = MapID: MapID = MapID - 1
        ActString = "Contraband Farms"
    Case 95 To 100
        MapPrev = MapID: MapID = MapID - 1
        ActString = "Amazing Cavern"
    Case 101, 102
        ActString = "Amazing Cavern"
    End Select 'Move left
    Do
        If CounterOn Then CountVar = CountVar + 1
        RenderMap 40, 30, 16, 16, Tiler, Mainsurf
        blt
        If CountVar >= 45 Then DXMode = 5: CountVar = 0: CounterOn = False: Me.Enabled = True
        bScroll = False
        DoEvents
    Loop Until CounterOn = False
ElseIf Self.J = 0 Then
    bJustScrolled = True
    DXMode = 2
    CounterOn = True
    Me.Enabled = False
    Self.J = 88
    Select Case MapID
    Case 0
        MapPrev = 0: MapID = 1
        ActString = "Initializa Plains"
    Case 2 To 7
        MapPrev = MapID: MapID = MapID + 2
        ActString = "Jusk Hills Zone"
    Case 10 To 14
        MapPrev = MapID: MapID = MapID + 1
        ActString = "Port Grier"
    Case 18 To 20
        MapPrev = MapID: MapID = MapID + 1
        ActString = "Wallway Mines"
    Case 28
        MapPrev = 28: MapID = 31
        ActString = "Njabroq Mountain"
    Case 37 To 39
        MapPrev = MapID: MapID = MapID - 5
        ActString = "Hexadiemme Lake"
    Case 41 To 47
        MapPrev = MapID: MapID = MapID + 1
        ActString = "Coineque di Pyreth Swamp"
    Case 71 To 76
        MapPrev = MapID: MapID = MapID - 2
        ActString = "Hiacojira Town"
    Case 83
        MapPrev = 83: MapID = 94
        ActString = "Nickel Desert Island Towers"
    Case 95 To 97
        MapPrev = MapID: MapID = MapID + 3
        ActString = "Amazing Cavern"
    Case 101, 102
        ActString = "Amazing Cavern"
    Case 103
        MapPrev = 103: MapID = 104
        ActString = "SFlag Shrine"
    End Select  'Move up
    Do
        If CounterOn Then CountVar = CountVar + 1
        RenderMap 40, 30, 16, 16, Tiler, Mainsurf
        blt
        If CountVar >= 35 Then DXMode = 5: CountVar = 0: CounterOn = False: Me.Enabled = True
        bScroll = False
        DoEvents
    Loop Until CounterOn = False
ElseIf Self.J = BIGY - 1 Then
    bJustScrolled = True
    DXMode = 4
    CounterOn = True
    Me.Enabled = False
    Self.J = 1
    Select Case MapID
    Case 1
        MapPrev = 1: MapID = 0
        ActString = "Initializa Plains"
    Case 4 To 9
        MapPrev = MapID: MapID = MapID - 2
        ActString = "Jusk Hills Zone"
    Case 11 To 15
        MapPrev = MapID: MapID = MapID - 1
        ActString = "Port Grier"
    Case 19 To 21
        MapPrev = MapID: MapID = MapID - 1
        ActString = "Wallway Mines"
    Case 31
        MapPrev = 31: MapID = 28
        ActString = "Njabroq Mountain"
    Case 32 To 34
        MapPrev = MapID: MapID = MapID + 5
        ActString = "Hexadiemme Lake"
    Case 41 To 47
        MapPrev = MapID: MapID = MapID - 1
        ActString = "Coineque di Pyreth Swamp"
    Case 49 To 63
        MapPrev = MapID: MapID = MapID + 1
        ActString = "D'boutit Peaks"
    Case 71 To 76
        MapPrev = MapID: MapID = MapID + 2
        ActString = "Hiacojira Town"
    Case 94
        MapPrev = 94: MapID = 83
        ActString = "Nickel Desert Island Towers"
    Case 98 To 100
        MapPrev = MapID: MapID = MapID - 3
        ActString = "Amazing Cavern"
    Case 101, 102
        ActString = "Amazing Cavern"
    Case 104
        MapPrev = 104: MapID = 103
        ActString = "SFlag Shrine"
    End Select 'Move down
    Do
        If CounterOn Then CountVar = CountVar + 1
        RenderMap 40, 30, 16, 16, Tiler, Mainsurf
        blt
        If CountVar >= 35 Then DXMode = 5: CountVar = 0: CounterOn = False: Me.Enabled = True
        bScroll = False
        DoEvents
    Loop Until CounterOn = False
End If
End Sub
Private Sub MapChecker(ByVal B As String)
Dim C As String, D As String, Extr As String, Junk As Boolean, X As Integer, Y As Integer
    C = Map(Self.I, Self.J, MapID)
    If Left$(C, 1) = "?" And B = Left$(C, 1) Then
        ActString = Mid(C, 2): DXMode = 5
    ElseIf C = "o" Or C = "p" Or C = "q" Then
        Self = SeekValueInMap(C, MapID, Self)
    ElseIf C = "U" And B = C Then
        SwitchColor True, False, False, MapID
    ElseIf C = "V" And B = C Then
        SwitchColor False, False, True, MapID
    ElseIf C = "W" And B = C Then
        SwitchColor False, True, False, MapID
    ElseIf C = "/" Then
        Junk = InBoxSet("Pass", True)
        'A new sub.  This will find a tile that occurs twice and place it under the passgate.
        If Junk Then
            Map(Self.I, Self.J, MapID) = SuitableReplacement(Self.I, Self.J, MapID)
        End If
    ElseIf OnSkiLift Then
        If OnSkiLift = 1 Then
            OnLift = True: OnLift2 = False
        ElseIf OnSkiLift = 2 Then
            OnLift2 = True: OnLift = False
        End If
    Else
        OnLift = False: OnLift2 = False
    End If
    If Left(C, 1) = "!" Then
        D = Mid(C, 2, Len(C) - 1)
        If IsNumeric(D) Then
            Score = Score + Val(D)
            ActString = D & " points!": DXMode = 5
            Map(Self.I, Self.J, MapID) = SuitableReplacement(Self.I, Self.J, MapID)
        Else
            Boxset.Add Mid$(C, 2)
            ActString = D: DXMode = 5
            Map(Self.I, Self.J, MapID) = SuitableReplacement(Self.I, Self.J, MapID)
            If Mid$(C, 2, 4) = "SFla" Then
                SaveLoc.I = Self.I
                SaveLoc.J = Self.J
                SaveLoc.K = MapID
                SaveGrad.I = gmR
                SaveGrad.J = gmG
                SaveGrad.K = gmB
                SaveToFile DestFile
            End If
        End If
    End If
    If CBool(InStr(1, ";{|}", C)) And Not CBool(OnSkiLift) Then
        Select Case MapID
        Case 25
            MapPrev = 25: MapID = 24
        Case 26
            MapPrev = 26: MapID = 25
            If Map(Self.I, Self.J, MapID) = ";" Or Map(Self.I, Self.J, MapID) = "{" Then MapID = 24
        Case 29
            MapPrev = 29: MapID = 28
        Case 35
            MapPrev = 35: MapID = 34
        Case 40
            MapPrev = 40: MapID = 41
        Case 83 To 93
            For MapID = MapID To 83 Step -1
                If Not (Map(Self.I, Self.J, MapID) = "{" Or Map(Self.I, Self.J, MapID) = "}") Then Exit For
                'Drop till we hit the floor
            Next
        Case 94
            MapPrev = 94: MapID = 96
            ActString = "Amazing Cavern": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\basis.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors -22, -20, -20
            TileSet = 2
        Case Else
            EndIt 3
        End Select
    ElseIf C = "^" Then
        EndIt 6
    ElseIf C = ">" Then         'Upstairs
        Select Case MapID
        Case 16
            MapPrev = 16: MapID = 15
            TileSet = 1
        Case 17
            MapPrev = 17: MapID = 16
        Case 22 To 29
            MapPrev = MapID: MapID = MapID + 1
        Case 34
            MapPrev = 34: MapID = 35
        Case 41
            MapPrev = 41: MapID = 40
        Case 83 To 93
            MapPrev = MapID: MapID = MapID + 1
        Case 101, 102
            MapID = MapID - 1: MapPrev = MapID
        End Select
    ElseIf C = "<" Then
        Select Case MapID
        Case 15
            MapPrev = 15: MapID = 16
            TileSet = 2
        Case 16
            MapPrev = 16: MapID = 17
        Case 23 To 30
            MapPrev = MapID: MapID = MapID - 1
        Case 35
            MapPrev = 35: MapID = 34
        Case 40
            MapPrev = 40: MapID = 41
        Case 83 To 93
            MapPrev = MapID: MapID = MapID - 1
        Case 100, 101
            MapID = MapID + 1: MapPrev = MapID
'        Case 49
'            For X = 0 To 2
'                Junk = InBoxSet("Icon", True)
'                If Junk = False Then
'                    For Y = 0 To (X - 1)
'                        Boxset.Add "Icon"
'                    Next
'                    X = 3
'                End If
'            Next
'            If Junk Then
'                For Y = 0 To (X - 1)
'                    Boxset.Add "Icon"
'                Next
'                MapPrev = 49: MapID = 54
'                ActString = "Inbindo Heights": DXMode = 5
'            End If
'        Case 234
'            MapPrev = 234: MapID = 247
'            ActString = "Automatic Save... Pacific Palace Style": DXMode = 5
'            SaveLoc.I = Self.I
'            SaveLoc.J = Self.J
'            SaveLoc.K = MapID
'            SaveGrad.I = gmR
'            SaveGrad.J = gmG
'            SaveGrad.K = gmB
'            DXMode = 5
        End Select
    ElseIf C = " " Then
        Select Case MapID
        Case 1
            MapPrev = 1: MapID = 2
            ActString = "Jusk Hills Zone": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\heights.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 0, 0
            TileSet = 0
            wtFog = False
        Case 2
            MapPrev = 2: MapID = 1
            ActString = "Initializa Plains": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\adventure.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 0, 0
            TileSet = 0
            wtFog = False
        Case 5
            MapPrev = 5: MapID = 10
            ActString = "Port Grier": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\blizz.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 0, 0
            TileSet = 1
        Case 10
            MapPrev = 10: MapID = 5
            ActString = "Jusk Hills Zone": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\heights.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 0, 0
            TileSet = 0
        Case 17
            MapPrev = 17: MapID = 18
            ActString = "Wallway Mines": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\tunnel.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 0, 0
            TileSet = 2
        Case 18
            MapPrev = 18: MapID = 17
            ActString = "Port Grier": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\blizz.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 0, 0
            TileSet = 2
        Case 21
            MapPrev = 21: MapID = 22
            ActString = "Njabroq Mountain": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\snow.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors -15, 15, 5
            TileSet = 1
        Case 22
            MapPrev = 22: MapID = 21
            ActString = "Wallway Mines": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\tunnel.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 0, 0
            TileSet = 2
        Case 25
            MapPrev = 25: MapID = 29
            ActString = "Njabroq Mountain": DXMode = 5
        Case 29
            MapPrev = 29: MapID = 25
            ActString = "Njabroq Mountain": DXMode = 5
        Case 30
            MapPrev = 30: MapID = 32
            ActString = "Hexadiemme Lake": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\icebeach.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 11, 0, 0
            TileSet = 3
        Case 32
            MapPrev = 32: MapID = 30
            ActString = "Njabroq Mountain": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\snow.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors -15, 15, 5
            TileSet = 1
        Case 33
            MapPrev = 33: MapID = 46
            ActString = "Coineque di Pyreth Swamp": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\jungilis.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors -20, -18, -20
            TileSet = 0
        Case 37
            MapPrev = 37: MapID = 40
            ActString = "Coineque di Pyreth Swamp": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\jungilis.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors -20, -18, -20
            TileSet = 0
        Case 40
            MapPrev = 40: MapID = 37
            ActString = "Hexadiemme Lake": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\icebeach.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 11, 0, 0
            TileSet = 3
        Case 46
            MapPrev = 46: MapID = 33
            ActString = "Hexadiemme Lake": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\icebeach.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 11, 0, 0
            TileSet = 3
        Case 47
            MapPrev = 47: MapID = 49
            ActString = "D'boutit Peaks": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\boutit~1.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 0, 6
            TileSet = 1
        Case 49
            MapPrev = 49: MapID = 47
            ActString = "Coineque di Pyreth Swamp": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\jungilis.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors -20, -18, -20
            TileSet = 0
        Case 58
            MapPrev = 58: MapID = 60
            ActString = "D'boutit Peaks": DXMode = 5
        Case 60
            MapPrev = 60: MapID = 58
            ActString = "D'boutit Peaks": DXMode = 5
        Case 63
            MapPrev = 63: MapID = 64
            ActString = "Bundirec Grassland": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\rockma~1.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 10, 10, 0
            TileSet = 4
        Case 64
            MapPrev = 64: MapID = 63
            ActString = "D'boutit Peaks": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\boutit~1.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 0, 6
            TileSet = 1
        Case 69
            MapPrev = 69: MapID = 73
            ActString = "Hiacojira Town": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\japja.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 12, 0
            TileSet = 3
        Case 70
            MapPrev = 70: MapID = 74
            ActString = "Hiacojira Town": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\japja.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 12, 0
            TileSet = 3
        Case 73
            MapPrev = 73: MapID = 69
            ActString = "Bundirec Grassland": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\rockma~1.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 10, 10, 0
            TileSet = 4
        Case 74
            MapPrev = 74: MapID = 70
            ActString = "Bundirec Grassland": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\rockma~1.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 10, 10, 0
            TileSet = 4
        Case 76
            MapPrev = 76: MapID = 81
            ActString = "Contraband Farms": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\zerolith.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors -22, -38, -22
            TileSet = 0
        Case 77
            MapPrev = 77: MapID = 83
            ActString = "Nickel Desert Island Towers": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\crforest.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors -8, -8, -8
            TileSet = 4
        Case 81
            MapPrev = 81: MapID = 76
            ActString = "Hiacojira Town": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\japja.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 12, 0
            TileSet = 3
        Case 83
            MapPrev = 83: MapID = 77
            ActString = "Contraband Farms": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\zerolith.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors -22, -38, -22
            TileSet = 0
        Case 102
            MapPrev = 102: MapID = 103
            ActString = "SFlag Shrine": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\adventure.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors 0, 0, 0
            TileSet = 0
        Case 103
            MapPrev = 103: MapID = 102
            ActString = "Amazing Cavern": DXMode = 5
            StopDXMusic
            ChangeDXMusicFile App.Path & "\basis.mid"
            LoopRepeatDXMusic -1
            PlayDXMusic
            SetGMColors -22, -20, -20
            TileSet = 2
        Case 104
            If Self.I = 47 Then
                XCnt = 0
                If InBoxSet("SFlag 1", True) Then Map(41, 65, 104) = "'": XCnt = XCnt + 1
                If InBoxSet("SFlag 2", True) Then Map(45, 65, 104) = "'": XCnt = XCnt + 1
                If InBoxSet("SFlag 3", True) Then Map(49, 65, 104) = "'": XCnt = XCnt + 1
                If InBoxSet("SFlag 4", True) Then Map(53, 65, 104) = "'": XCnt = XCnt + 1
                If InBoxSet("SFlag 5", True) Then Map(41, 68, 104) = "'": XCnt = XCnt + 1
                If InBoxSet("SFlag 6", True) Then Map(45, 68, 104) = "'": XCnt = XCnt + 1
                If InBoxSet("SFlag 7", True) Then Map(49, 68, 104) = "'": XCnt = XCnt + 1
                If InBoxSet("SFlag 8", True) Then Map(53, 68, 104) = "'": XCnt = XCnt + 1
                If InBoxSet("SFlag 9", True) Then Map(41, 71, 104) = "'": XCnt = XCnt + 1
                If InBoxSet("SFlag 10", True) Then Map(53, 71, 104) = "'": XCnt = XCnt + 1
                If InBoxSet("SFlag 11", True) Then Map(41, 74, 104) = "'": XCnt = XCnt + 1
                If InBoxSet("SFlag 12", True) Then Map(53, 74, 104) = "'": XCnt = XCnt + 1
                If XCnt >= 12 Then
                    DXMode = 5
                    ActString = "You have finished the game.  Congratulations.  The Code is HEAVILY MEDICATED!"
                    StopDXMusic
                    ChangeDXMusicFile App.Path & "\fanfare.mid"
                    PlayDXMusic
                    SetGMColors 10, 10, 10
                    Map(Self.I + 1, Self.J + 1, 104) = "?The Code is HEAVILY MEDICATED!"
                    Map(Self.I + 1, Self.J - 1, 104) = "?Go to the west for your surprise!"
                    bFlagged = True
                End If
                XCnt = 0
            ElseIf Self.I = 98 Then
                XCnt = 0
                If InBoxSet("Winter Flag", True) Then Map(95, 40, 104) = "&": XCnt = XCnt + 1
                If InBoxSet("Spring Flag", True) Then Map(102, 40, 104) = "&": XCnt = XCnt + 1
                If InBoxSet("Summer Flag", True) Then Map(95, 46, 104) = "&": XCnt = XCnt + 1
                If InBoxSet("Autumn Flag", True) Then Map(102, 46, 104) = "&": XCnt = XCnt + 1
                If XCnt >= 4 Then
                    DXMode = 5
                    ActString = "You have COMPLETED the game!  The Code is HEAVILY DOSED!"
                    StopDXMusic
                    ChangeDXMusicFile App.Path & "\icebeach.mid"
                    LoopRepeatDXMusic -1
                    PlayDXMusic
                    SetGMColors 30, 30, 30
                    Map(Self.I + 1, Self.J + 1, 104) = "?The Code is HEAVILY DOSED!"
                End If
            ElseIf bFlagged = True Then
                DXMode = 7
                InitSurfaces
                CredScroll = 0
                StopDXMusic
                ChangeDXMusicFile App.Path & "\boutit~1.mid"
                LoopRepeatDXMusic -1
                PlayDXMusic
            End If
        End Select
        'this is to make sure that the music is automatically repeating

    ElseIf C = Chr$(19) Then
        RunAnEvent primary
    ElseIf C = Chr$(18) Then
        InBoxSet "Raft", True
        InBoxSet "Jump Boots", True
        InBoxSet "Extinguisher", True
        InBoxSet "Shock Wave", True
        InBoxSet "Napalm", True
        InBoxSet "Freeze Beam", True
    ElseIf C = Chr$(20) Then
        SetDXSound App.Path & "\exposion.wav", 0
        PlayDXSound 0, DSBPLAY_DEFAULT
        Map(Self.I, Self.J, MapID) = "8"
        Map(Self.I - 1, Self.J - 1, MapID) = "8"
        Map(Self.I - 1, Self.J, MapID) = "8"
        Map(Self.I - 1, Self.J + 1, MapID) = "8"
        Map(Self.I + 1, Self.J - 1, MapID) = "8"
        Map(Self.I + 1, Self.J, MapID) = "8"
        Map(Self.I + 1, Self.J + 1, MapID) = "8"
        Map(Self.I, Self.J - 1, MapID) = "8"
        Map(Self.I, Self.J + 1, MapID) = "8"
        For X = 0 To 4
            If Explosion(X).K = 0 Then
                Explosion(X).I = Self.I
                Explosion(X).J = Self.J
                Explosion(X).K = 1
                X = 4
            End If
        Next
    End If
    If Asc(C) >= Asc("[") And Asc(C) <= Asc("]") And B = C Then
        C = Chr(Asc(C) - 1)
        If C < "[" Then C = "2"
        Map(Self.I, Self.J, MapID) = C
    End If
End Sub
Sub SetupGamma()
'This is the gamma initialization
On Error GoTo GamErr:
If GammaSupport = False Then Exit Sub 'We dont want to be here
'if we cant do gamma...


'Make a new gamma controler
If GammaSupport = True Then
Set GammaControler = primary.GetDirectDrawGammaControl
'Fill out the original gamma ramps
GammaControler.GetGammaRamp DDSGR_DEFAULT, OriginalRamp
End If

'0 is default
'-numbers are darker
'+numbers are lighter
Exit Sub
GamErr:
#If 0 Then
    Debug.Print "Error in gamma stuff"
#End If
End Sub
'Current position: 20,40,98
'Map(19, 40, 98) = "+"
'Boxset.Add "Pass"
'Self.J = Self.J - 2
'Darkself(105).IntelligenceInt = 0
'MapID = 101
'What you can do if you are determined enough...

Public Sub SetGamma(intRed As Integer, intGreen As Integer, intBlue As Integer)
'This code is taken directly from www.directx4vb.com/ 's website - credit to whoever this belongs to.
'Your name here
On Error GoTo GamOut:
Dim I As Integer

'The values of -99 to +99 aren't DirectDraw things, whoever wrote this
'function made it for our ease... gee, I wish I knew who wrote this stuff

If GammaSupport = True Then
'Alter the gamma ramp to the percent given by comparing to original state
'A value of zero ("0") for intRed, intGreen, or intBlue will result in the
'gamma level being set back to the original levels. Anything ABOVE zero will
'fade towards FULL colour, anything below zero will fade towards NO colour
    For I = 0 To 255
        If intRed < 0 Then GammaRamp.red(I) = ConvToSignedValue(ConvToUnSignedValue(OriginalRamp.red(I)) * (100 - Abs(intRed)) / 100)
        If intRed = 0 Then GammaRamp.red(I) = OriginalRamp.red(I)
        If intRed > 0 Then GammaRamp.red(I) = ConvToSignedValue(65535 - ((65535 - ConvToUnSignedValue(OriginalRamp.red(I))) * (100 - intRed) / 100))
        If intGreen < 0 Then GammaRamp.green(I) = ConvToSignedValue(ConvToUnSignedValue(OriginalRamp.green(I)) * (100 - Abs(intGreen)) / 100)
        If intGreen = 0 Then GammaRamp.green(I) = OriginalRamp.green(I)
        If intGreen > 0 Then GammaRamp.green(I) = ConvToSignedValue(65535 - ((65535 - ConvToUnSignedValue(OriginalRamp.green(I))) * (100 - intGreen) / 100))
        If intBlue < 0 Then GammaRamp.blue(I) = ConvToSignedValue(ConvToUnSignedValue(OriginalRamp.blue(I)) * (100 - Abs(intBlue)) / 100)
        If intBlue = 0 Then GammaRamp.blue(I) = OriginalRamp.blue(I)
        If intBlue > 0 Then GammaRamp.blue(I) = ConvToSignedValue(65535 - ((65535 - ConvToUnSignedValue(OriginalRamp.blue(I))) * (100 - intBlue) / 100))
    Next
GammaControler.SetGammaRamp DDSGR_DEFAULT, GammaRamp
End If
Exit Sub
GamOut:
#If 0 Then
    Debug.Print "Error in Gamma procedure"
#End If
End Sub

'These two parts go with the above Gamma function.
Private Function ConvToSignedValue(lngValue As Long) As Integer
    If lngValue <= 32767 Then
        ConvToSignedValue = CInt(lngValue)
    Else
        ConvToSignedValue = CInt(lngValue - 65535)
    End If
End Function
Private Function ConvToUnSignedValue(intValue As Integer) As Long
    If intValue >= 0 Then
        ConvToUnSignedValue = intValue
    Else
        ConvToUnSignedValue = intValue + 65535
    End If
End Function
Sub CheckForGammaSupport()
Dim Hard As DDCAPS, Soft As DDCAPS
Dim lVal As Long
dd.GetCaps Hard, Soft

If (Hard.lCaps2 And DDCAPS2_PRIMARYGAMMA) = 0 Then
    GammaSupport = False
Else
    GammaSupport = True
End If
End Sub

Private Sub SaveToFile(Filename As String)
Dim Xf As Integer, Yf As Integer, SendStr As String, Substr As String
'We are now copying the entire map into one file... which shouldn't get
'big until the complete version. (with 12 SFlags, 12 regions...)
If Len(Filename) = 0 Then Exit Sub
Open App.Path & "\" & Filename & ".qls" For Output As #1
    For Yf = 0 To DPointCount - 1
'        For Xf = 0 To BIGX - 1
'            Substr = Map(Xf, Yf Mod BIGY, Yf \ BIGY)
'            If Len(Substr) > 1 Then Substr = Substr & "@"
'            SendStr = SendStr & Substr
'        Next
        With DataPoints(Yf)
            SendStr = Map(.I, .J, .K)
            'Write whatever is currently at the spot that we cleared to file
            'This is the compression I was talking about
        End With
        Print #1, SendStr
        SendStr = ""
    Next
    For Xf = 1 To Boxset.Count
        Print #1, Boxset(Xf)
    Next
    'Send the special data
    Print #1, Format$(DayClock, "0000000")
    Print #1, Format$(Score, "0000000")
    Print #1, Format$(Self.I, "00")
    Print #1, Format$(Self.J, "00")
    Print #1, Format$(MapID, "000")
Close #1
End Sub
Private Sub ReadFromFile(Filename As String)
Dim w As Long, v As Long, z As String, Stri As String, secondstring As String, SecondEnd As Integer
If Len(Filename) = 0 Then Exit Sub
'Reads the whole file back.
Open App.Path & "\" & Filename & ".qls" For Input As #1
    For v = 0 To DPointCount - 1
        Line Input #1, Stri  'Get the line
        With DataPoints(v)
            Map(.I, .J, .K) = Stri
        End With
        
'        Debug.Assert Len(Stri) >= 120
'        For w = 0 To BIGX - 1
'            z = Mid$(Stri, w + 1, 1)
'            'If binit = False Then
'            Map(w, v Mod BIGY, v \ BIGY) = z
''            Debug.Assert Not (v = 476 And w = 105)
'            'ElseIf z <> "/" And z <> "?" And z <> "!" And z <> "(" And z <> ")" And z <> "*" Then
'            '    Map(w, v Mod 30, v \ 30) = z 'Inject into the map
'            'End If
'            If z = "?" Then     'Check for a sign.
'                secondstring = Mid$(Stri, w + 2)
'                SecondEnd = InStr(1, secondstring, "@", vbBinaryCompare)
'                'If binit = False Then
'                Map(w, v Mod BIGY, v \ BIGY) = "?" & Mid$(secondstring, 1, SecondEnd - 1)
'                Stri = Left$(Stri, w) & "?" & Mid$(Stri, w + SecondEnd + 2)
'                'Sign contents go into the tile.
'            ElseIf z = "!" Then    'Check for treasure
'                secondstring = Mid$(Stri, w + 2)
'                SecondEnd = InStr(1, secondstring, "@", vbBinaryCompare)
'                'If binit = False Then
'                Map(w, v Mod BIGY, v \ BIGY) = "!" & Mid$(secondstring, 1, SecondEnd - 1)
'                Stri = Left$(Stri, w) & "!" & Mid$(Stri, w + SecondEnd + 2)
'                'Treasure contents go into the tile.
'                'These will be recognized by finding the ! and ? as the first characters
'            ElseIf z = ";" And v Mod BIGY > 0 Then
'                If Map(w, (v - 1) Mod BIGY, v \ BIGY) = ";" Or Map(w, (v - 1) Mod BIGY, v \ BIGY) = "{" Then Map(w, v Mod BIGY, v \ BIGY) = "{"
'            End If
'        Next
    Next
    For w = 1 To Boxset.Count
        Boxset.Remove 1
    Next
    Do Until EOF(1)
        Line Input #1, z
        Boxset.Add z
    Loop
    MapID = Val(Boxset(Boxset.Count))
    Boxset.Remove Boxset.Count
    Self.J = Val(Boxset(Boxset.Count))
    Boxset.Remove Boxset.Count
    Self.I = Val(Boxset(Boxset.Count))
    Boxset.Remove Boxset.Count
    Score = Val(Boxset(Boxset.Count))
    Boxset.Remove Boxset.Count
    DayClock = Val(Boxset(Boxset.Count))
    Boxset.Remove Boxset.Count
Close #1
End Sub
Public Sub RecalibrateLargeTile()
Dim bl As Integer, bt As Integer
bl = LTile
bt = TTile
If Self.I < 19 Then   'On far left edge
    LTile = 0
ElseIf Self.I > BIGX - 20 Then   'On far right edge
    LTile = BIGX - 40
ElseIf Self.I - LTile < 19 Then  'On left side of screen
    LTile = Self.I - 19
ElseIf Self.I - LTile > 20 Then  'On right side of screen
    LTile = Self.I - 20
Else
End If
If Self.J < 14 Then
    TTile = 0
ElseIf Self.J > BIGY - 15 Then
    TTile = BIGY - 30
ElseIf Self.J - TTile < 14 Then
    TTile = Self.J - 14
ElseIf Self.J - TTile > 15 Then
    TTile = Self.J - 15
Else
End If
If LTile <> bl And Not bJustScrolled Then
    If bl > -1 And bl < 81 Then bScroll = True
End If
If TTile <> bt And Not bJustScrolled Then
    If bt > -1 And bt < 61 Then bScroll = True
End If
End Sub
Public Sub KeyDownicEvent()
Dim LV As Integer
Static LastArrow As Integer
bScroll = False                                                             'test
For LV = 37 To 40
    If GetAsyncKeyState(LV) < 0 Then
        If LastArrow = LV - 36 Then                                         'Test in another procedure please
            LastArrow = LV
        ElseIf LastArrow = LV Then
            bWalk = True                                                    'i'm not testing
            Call Form_KeyDown(LV, 0)
        Else
            LastArrow = LV - 36
            bWalk = True
            Call Form_KeyDown(LV, 0)
        End If
        LV = 41
    ElseIf LastArrow Mod 4 = LV Mod 4 Then
        LastArrow = 0                                                       'test
    End If
Next
If LV = 41 Then dWalk = 0
For LV = 73 To 78                                                           'test
    If GetAsyncKeyState(LV) < 0 Then
        Call Form_KeyDown(LV, 0)
        LV = 79
    End If
Next
End Sub
