Attribute VB_Name = "Quadrill3"

Public Declare Sub Sleep Lib "Kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function GetKeyState Lib "user32.dll" (ByVal nVirtKey As Long) As Integer
Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
'Key state 0 -> -128 -> 1 -> -127
'             Rel   Press  Rel   Press
Public Const MAPMAX As Integer = 104    'How big the game is.
Public Const BIGX As Integer = 120  'Left screen width
Public Const BIGY As Integer = 90   'Top screen height
Public Const Chr24 As String = ""   'So that I don't have to use the function. :)
Public Const Chr25 As String = ""
Public Const Chr23 As String = ""
Public Const ChrBelts As String = ""   '28, 29, 30, and 31, respectively
Public Type Vector2D
    I As Single
    J As Single
End Type
Public Type Vector3D
    I As Single
    J As Single
    K As Single
End Type
Public Enum VCoords
    I_Coord = 0
    J_Coord
    K_Coord
End Enum
Public Enum Direction
    LeftDir = 0
    UpDir
    RightDir
    DownDir
End Enum
Public Enum ProjectileType
    Extinguisher = 0
    ShockWave
    Napalm
    FreezeBeam
End Enum
Public Type Prje
'Contains definition for anything that is being shot along the field.
    L As Vector3D
    Direc As Direction
    UsedBySelf As Boolean
    T As ProjectileType
    Activated As Boolean
End Type
Public Type Antagonist
    L As Vector3D
    Direc As Direction
    Throws As ProjectileType
    Activated As Boolean
    IntelligenceInt As Byte
End Type
Public WindowMode As Boolean   'Useless, I think
Public Map(0 To BIGX - 1, 0 To BIGY - 1, 0 To MAPMAX) As String    'The actual map info
Public Self As Vector2D     'Me
Public SDir As Direction         'Where am I facing
Public MapID As Integer     'My map number
Public MapPrev As Integer   'Where I was
Public TileSet As Integer  'Denotes tileset
Public Explosion(0 To 4) As Vector3D  'Up to 5 explosions going off simultaneously.
Public Projectile(0 To 9) As Prje       '
Public Darkself(0 To 107) As Antagonist     'Fighter data
Public DataPoints(0 To 499) As Vector3D  'Stores the location of chests/passes/locked doors
Public DPointCount As Integer

Public DestFile As String   'Filename to save to
Public wtFog As Boolean     'Turn this on for fog. :)
Public wtRain As Boolean    'Turn this on for rain.
Public wtAlert As Boolean   'Yeah, this is not weather... turn this on for an alarm light.
Public Score As Integer     'My score
Public Boxset As New Collection
Public OnRed(0 To MAPMAX) As Boolean, OnGreen(0 To MAPMAX) As Boolean, OnBlue(0 To MAPMAX) As Boolean
Public LastTog As Byte, SecTog As Byte
Public Skilift As Vector2D, Skilift2 As Vector2D, DayClock As Long, OnLift As Boolean, OnLift2 As Boolean
Public Beast(0 To 4) As Vector2D
Public Tries As Byte
Public SaveLoc As Vector3D
Public SaveGrad As Vector3D
Public WindValue(0 To MAPMAX, 0 To 2) As Byte
Public mtTime As Long
Public dtempo As Double
'''''''We need a root object:
Public dmusic As New DirectX7
Public SoundOff As Boolean

'A performance controls the music. It looks after
'sending data to the music port, setting options
'converting time sigs. etc...
Public PSong As DirectMusicPerformance
'A segment is where the actual data is stored;
'like a buffer or a surface in other DirectX objects
Public Seg As DirectMusicSegment
'This variable lets us know what the music is
'doing. At the simplest level this is "am I playing?"
'"am i stopped?" etc.......
Public segstate As DirectMusicSegmentState
'A loader object is what parses the data from a file
'on the hard drive to the area in memory.
Public loader As DirectMusicLoader
Private ds As DirectSound
Private dsWave As WAVEFORMATEX
Private dsDesc As DSBUFFERDESC
Private dsBuffer(0 To 2) As DirectSoundBuffer
Private dsEnum As DirectSoundEnum
Public Sub SetupDXSound(hWnd As Long, dx As DirectX7)
Set dsEnum = dx.GetDSEnum
'Holds sound driver info.
Set ds = dx.DirectSoundCreate(dsEnum.GetGuid(1))
ds.SetCooperativeLevel hWnd, DSSCL_EXCLUSIVE
'Exclusive means only we get the sounds.
dsDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME Or DSBCAPS_STATIC
'What we can control.
dsWave.nFormatTag = WAVE_FORMAT_PCM
'Only one that doesn't make errors. :)
dsWave.nChannels = 2  'This means Stereo, 1 is mono
dsWave.lSamplesPerSec = 22050  'Cool
dsWave.nBitsPerSample = 16  'Ya know... 16-bit sound
dsWave.nBlockAlign = dsWave.nBitsPerSample / 8 * dsWave.nChannels
'That comes out to be 4... I could've substituted that.
dsWave.lAvgBytesPerSec = dsWave.lSamplesPerSec * dsWave.nBlockAlign
'And that comes out to be 5512.5 ... hmm...
'The end... now to set the filename...
End Sub
Public Sub SetDXSound(Filename As String, Index As Byte)
Set dsBuffer(Index) = ds.CreateSoundBufferFromFile(Filename, dsDesc, dsWave)
End Sub
Public Sub DXSoundShutDown()
Set dsBuffer(2) = Nothing
Set dsBuffer(1) = Nothing
Set dsBuffer(0) = Nothing
Set dsEnum = Nothing
Set ds = Nothing
End Sub
Public Sub PlayDXSound(Index As Byte, Playstyle As CONST_DSBPLAYFLAGS, Optional Vol As Long = -1000, Optional f As Long = DSBFREQUENCY_ORIGINAL, Optional Pan As Long = DSBPAN_CENTER)
dsBuffer(Index).SetPan Pan
dsBuffer(Index).SetFrequency f
dsBuffer(Index).SetVolume Vol
dsBuffer(Index).Play Playstyle
'Guess what these do. :)
End Sub
Public Sub StopDXSound(Index As Byte)
dsBuffer(Index).Stop
'This alone only pauses the stuff.
dsBuffer(Index).SetCurrentPosition 0
'This is like rewind.
End Sub
Public Sub PauseDXSound(Index As Byte)
dsBuffer(Index).Stop
'As the previous sub concept is implemented here.
End Sub
Public Sub UnpauseDXSound(Index As Byte, Playstyle As CONST_DSBPLAYFLAGS)
Dim Dscs As DSCURSORS
dsBuffer(Index).GetCurrentPosition Dscs
'The difference between play and unpause is that
'unpause requires the buffer to be playing
If Dscs.lPlay > 0 Then dsBuffer(Index).Play Playstyle
'See?
End Sub

Public Sub SetUpDXMusic(ByVal Midifile As String)

'Create our loader object. Used in cmdStep2
Set loader = dmusic.DirectMusicLoaderCreate()

'A performance is what organizes the events
'think of it as a conductor - synchronizing things
'setting things up; looking after the individual pieces
'of music.

'Create the performance
Set PSong = dmusic.DirectMusicPerformanceCreate()
'initialize it
Call PSong.Init(Nothing, 0)
'Set it's options - these options should be standard
'across most projects.
PSong.SetPort -1, 80
Call PSong.SetMasterAutoDownload(True)

PSong.SetMasterVolume 0
Set Seg = loader.LoadSegment(Midifile)
'Set the format of the segment to be a MIDI.
Seg.SetStandardMidiFile

Exit Sub

LocalErrors:
MsgBox "There was an Error in loading music", vbOKOnly, "DirectMusic MIDI"


End Sub
Public Sub PlayDXMusic()
If SoundOff = False Then Set segstate = PSong.PlaySegment(Seg, 0, 0)
End Sub
Public Sub StopDXMusic()
If SoundOff = False Then Call PSong.Stop(Seg, segstate, 0, 0)
End Sub
Public Sub CloseDXMusic()
PSong.CloseDown
End Sub
Public Sub LoopRepeatDXMusic(ByVal Repeats As Integer)
Seg.SetLoopPoints 0, 0
Seg.SetRepeats Repeats
End Sub
Public Sub ChangeDXMusicFile(ByVal Midifile As String)
Set Seg = loader.LoadSegment(Midifile)
End Sub
Public Sub CheckDXMusic()
If Not PSong.IsPlaying(Seg, segstate) Then
    PSong.Reset 0
    Set segstate = PSong.PlaySegment(Seg, 0, 0)
End If
End Sub
Public Sub SetDXVolume(nVolume As Byte)
'This formula allows you to specify a volume between
'0-100; similiar to a percentage
PSong.SetMasterVolume (nVolume * 42 - 3000)
End Sub

Public Function StepWave(ByVal Number As Integer) As Integer
Select Case Number Mod 4
Case 0, 2
    StepWave = 0
Case 1
    StepWave = 1
Case 3
    StepWave = -1
End Select
End Function
Public Function InBoxSet(ByVal strn As String, Destroy As Boolean) As Boolean
For A = 1 To Boxset.Count
    If Boxset(A) = strn Then
        InBoxSet = True
        If Destroy Then
            Boxset.Remove A
            Exit For
        End If
    End If
Next
End Function
Public Function OnSkiLift() As Byte
    OnSkiLift = 0
    If EqualVector2D(Self, Skilift) Then OnSkiLift = 1
    If EqualVector2D(Self, Skilift2) Then OnSkiLift = 2
End Function
Public Function OnBeast() As Byte
BeastPsn
For X = 0 To 4
    If EqualVector2D(Self, Beast(X)) Then OnBeast = X + 1
Next
End Function
Public Function MoveAllProjies() As ProjectileType
Dim G As Integer, H As Integer, Testr As String
For G = 0 To UBound(Projectile)
    With Projectile(G)
        If .Activated Then
            .L = LookVector3D(.L, .Direc)
            If .L.I = Self.I And .L.J = Self.J And .L.K = MapID Then MoveAllProjies = .T
            If InStr(1, "1`,(*)+PRTY^", Map(.L.I, .L.J, .L.K)) Then .Activated = False
            If .L.I = 0 Or .L.I = BIGX - 1 Or .L.J = 0 Or .L.J = BIGY - 1 Then .Activated = False
            If Map(.L.I, .L.J, .L.K) = "_" Then .Direc = (.Direc + 2) Mod 4
            If Map(.L.I, .L.J, .L.K) = "@" Then .Direc = (.Direc + 1) Mod 4
            If Map(.L.I, .L.J, .L.K) = "`" And .T = ShockWave Then Map(.L.I, .L.J, .L.K) = "7"
            If Map(.L.I, .L.J, .L.K) = "^" And .T = Extinguisher Then
                Map(.L.I, .L.J, .L.K) = "%"
                .Activated = False
                SetDXSound App.Path & "\wheeze.wav", 0
                PlayDXSound 0, DSBPLAY_DEFAULT, , 25000, (.L.I - Self.I) * 80
            End If
            If .Activated = False And .T = Napalm Then
                .L = LookVector3D(.L, (.Direc + 2) Mod 4)
                If Not CBool(InStr(1, "2;ZzOQSUVWopqrstu ?!/;{|", Left$(Map(.L.I, .L.J, .L.K), 1))) Then
                    Map(.L.I, .L.J, .L.K) = "^"
                    SetDXSound App.Path & "\exposion.wav", 0
                    PlayDXSound 0, DSBPLAY_DEFAULT, , , (.L.I - Self.I) * 83
                    For X = 0 To 4
                        If Explosion(X).K = 0 Then
                            Explosion(X).I = .L.I
                            Explosion(X).J = .L.J
                            Explosion(X).K = 1
                            X = 4
                        End If
                    Next
                End If
            ElseIf .T = FreezeBeam And .Activated = True Then
                Testr = Left$(Map(.L.I, .L.J, .L.K), 1)
                If Not CBool(InStr(1, "?!/OQSUVWopqrstu ABCDEFGHIJKLMNabcdefghijklmn""#:9;35{", Testr)) Then
                    If Testr = "Z" Then
                        Testr = "`"
                        'Ice turns to cracked wall.
                    ElseIf Testr = "^" Then
                        Testr = "2"
                        'Fire turns to water
                    ElseIf Testr = "2" Then
                        Testr = ":"
                        'Water turns to concrete
                    Else
                        Testr = "Z"
                        'Ground or anything else turns to ice
                    End If
                    Map(.L.I, .L.J, .L.K) = Testr
                End If
            ElseIf .T = FreezeBeam And .Activated = False Then
                If Left$(Map(.L.I, .L.J, .L.K), 1) = "^" Then Map(.L.I, .L.J, .L.K) = "2"
            End If
            For H = 0 To UBound(Darkself)
                If Darkself(H).L.K = MapID Then
                    If Darkself(H).L.I = .L.I And Darkself(H).L.J = .L.J Then
                        If .T > Extinguisher Then
                            Darkself(H).Activated = False
                            If Darkself(H).Throws = ShockWave Then
                                Map(Darkself(H).L.I, Darkself(H).L.J, Darkself(H).L.K) = "1"
                            ElseIf Darkself(H).Throws = Napalm Then
                                Map(Darkself(H).L.I, Darkself(H).L.J, Darkself(H).L.K) = "^"
                            End If
                        End If
                    End If
                ElseIf Darkself(H).L.K > MapID Then
                    H = UBound(Darkself)
                End If
            Next
        End If
    End With
Next
End Function
Public Sub ToggleFlashes(ByVal MapNumber As Integer)
For X = 0 To BIGX - 1
    For Y = 0 To BIGY - 1
        Toggle Map(X, Y, MapNumber), "X", "Y"
    Next
Next
End Sub
Public Function SpreadBlaze(MapNumber As Integer) As Byte
Dim BlazeL As Vector2D, LsX As Integer, LsY As Integer
BlazeL = SeekValueInMap("^", MapNumber, BlazeL, LsX, LsY)
Do While CBool(BlazeL.I) Or CBool(BlazeL.J)
    If BlazeL.I > 0 Then
        If InStr(1, "06794ABCDEFGHIJKLMNOQS=abcdefghijklmn#"",.-", Map(BlazeL.I - 1, BlazeL.J, MapNumber)) Then Map(BlazeL.I - 1, BlazeL.J, MapNumber) = Chr$(3)
    End If
    If BlazeL.J > 0 Then
        If InStr(1, "06794ABCDEFGHIJKLMNOQS=abcdefghijklmn#"",.-", Map(BlazeL.I, BlazeL.J - 1, MapNumber)) Then Map(BlazeL.I, BlazeL.J - 1, MapNumber) = Chr$(3)
    End If
    If BlazeL.I < BIGX - 1 Then
        If InStr(1, "06794ABCDEFGHIJKLMNOQS=abcdefghijklmn#"",.-", Map(BlazeL.I + 1, BlazeL.J, MapNumber)) Then Map(BlazeL.I + 1, BlazeL.J, MapNumber) = Chr$(3)
    End If
    If BlazeL.J < BIGY - 1 Then
        If InStr(1, "06794ABCDEFGHIJKLMNOQS=abcdefghijklmn#"",.-", Map(BlazeL.I, BlazeL.J + 1, MapNumber)) Then Map(BlazeL.I, BlazeL.J + 1, MapNumber) = Chr$(3)
    End If
    LsX = BlazeL.I: LsY = BlazeL.J
    If LsX > BIGX - 1 Then LsX = 0: LsY = LsY + 1
    BlazeL = SeekValueInMap("^", MapNumber, BlazeL, LsX, LsY)
Loop
For LsX = 0 To BIGX - 1
    For LsY = 0 To BIGY - 1
        If Map(LsX, LsY, MapNumber) = Chr$(3) Then Map(LsX, LsY, MapNumber) = "^"
    Next
Next
If Map(Self.I, Self.J, MapID) = "^" Then SpreadBlaze = 1
End Function
Public Function SuitableReplacement(ByVal nI As Integer, ByVal nJ As Integer, ByVal nMap As Integer) As String
Dim D As String, Extr As String, M As String
Const unSuitable As String = "1235<>ABCDEFGHIJKLMNabcdefghijklmnUVWXYopqrstuvwxy*()+-""#!?,/"
D = "": M = ""
For X = 0 To 3
    Extr = Left$(Map(nI + StepWave(X + 3), nJ + StepWave(X + 2), MapID), 1)
    If CBool(InStr(1, D, Extr)) Then
        M = M & Extr
    Else
        'Add to the test string
        D = D & Extr
    End If
Next
If Len(M) > 0 Then
    If Not CBool(InStr(1, unSuitable, Left$(M, 1))) Then
        SuitableReplacement = Left$(M, 1)
    ElseIf Len(M) > 1 Then
        SuitableReplacement = Mid$(M, 2, 1)
    Else
        M = ""
    End If
End If
If Len(M) = 0 Then
    If Not CBool(InStr(1, unSuitable, Left$(D, 1))) Then
        SuitableReplacement = Left$(D, 1)
    ElseIf Not CBool(InStr(1, unSuitable, Mid$(D, 2, 1))) Then
        SuitableReplacement = Mid$(D, 2, 1)
    ElseIf Not CBool(InStr(1, unSuitable, Mid$(D, 3, 1))) Then
        SuitableReplacement = Mid$(D, 3, 1)
    Else
        SuitableReplacement = Mid$(D, 4, 1)
    End If
End If
'Urgh... this is for no matches... pick one that isn't in the list or the bottom one.
        
End Function
Public Function DarkMakeMovement(ByVal nMap As Integer) As Boolean
Dim LV As Integer, L2 As Integer
For LV = 0 To UBound(Darkself)
    With Darkself(LV)
        If .Activated And nMap = .L.K Then
            If .IntelligenceInt = 0 Then
                'Different intelligence bracket.
                .Direc = Look3DAtVector2D(.L, Self)
                If .Direc = 4 Then
                    DarkMakeMovement = True
                    .Direc = LeftDir
                ElseIf DayClock Mod 150 = 28 Then   '5th cycles 3rd tick out of 30 cycles
                                                    '... all values have to have 3 ticks and X cycles
                    For L2 = 3 To 9
                        If Projectile(L2).Activated = False Then
                            Projectile(L2).Activated = True
                            Projectile(L2).Direc = .Direc
                            Projectile(L2).L = .L
                            Projectile(L2).T = .Throws
                            Projectile(L2).UsedBySelf = False
                            L2 = 10
                        End If
                    Next
                End If
            ElseIf .IntelligenceInt = 1 Then
                .Direc = Look3DAtVector2D(.L, Self)
                'This one will actually make an attempt to get to you.
                If .Direc = 4 Then
                    DarkMakeMovement = True
                    .Direc = LeftDir
                ElseIf DayClock Mod 30 = 3 Then  'Keep the same resolution that I had here for the movement
                    .L = LookVector3D(.L, .Direc)
                    If CBool(InStr(1, "1235BEHIKLMbehiklmr+,()*PRT/vwxy?""#_`;", Left$(Map(.L.I, .L.J, .L.K), 1))) Then .L = LookVector3D(.L, (.Direc + 2) Mod 4)
                    If DayClock Mod 300 = 63 Then  '60 cycles here
                        For L2 = 3 To 9
                            If Projectile(L2).Activated = False Then
                                Projectile(L2).Activated = True
                                Projectile(L2).Direc = .Direc
                                Projectile(L2).L = .L
                                Projectile(L2).T = .Throws
                                Projectile(L2).UsedBySelf = False
                                L2 = 10
                            End If
                        Next
                    End If
                End If
            ElseIf .IntelligenceInt = 2 Then
                .Direc = Look3DAtVector2D(.L, Self)
                'This one just sprays at you in your walking path
                If .Direc = 4 Then
                    DarkMakeMovement = True
                    .Direc = LeftDir
                ElseIf (Abs(Self.I - .L.I) < 5 Or Abs(Self.J - .L.J) < 5) And DayClock Mod 30 = 3 Then
                    For L2 = 3 To 9
                        If Projectile(L2).Activated = False Then
                            Projectile(L2).Activated = True
                            Projectile(L2).Direc = .Direc
                            Projectile(L2).L = .L
                            Projectile(L2).T = .Throws
                            Projectile(L2).UsedBySelf = False
                            L2 = 10
                        End If
                    Next
                End If
            ElseIf .IntelligenceInt = 3 Then
                .Direc = Look3DAtVector2D(.L, Self)
                'This one drops down to meet you horizontally
                If .Direc = 4 Then
                    DarkMakeMovement = True
                    .Direc = LeftDir
                Else
                    If .L.J < Self.J Then
                        .L = LookVector3D(.L, DownDir)
                        If CBool(InStr(1, "1235BEHIKLMbehiklmr+,()*PRT/vwxy?""#_`;", Left$(Map(.L.I, .L.J, .L.K), 1))) Then .L = LookVector3D(.L, UpDir)
                    ElseIf .L.J > Self.J Then
                        .L = LookVector3D(.L, UpDir)
                        If CBool(InStr(1, "1235BEHIKLMbehiklmr+,()*PRT/vwxy?""#_`;", Left$(Map(.L.I, .L.J, .L.K), 1))) Then .L = LookVector3D(.L, DownDir)
                    End If
                    If Self.I > .L.I Then
                        .Direc = RightDir
                    Else
                        .Direc = LeftDir
                    End If
                    If DayClock Mod 60 = 43 Then
                        For L2 = 3 To 9
                            If Projectile(L2).Activated = False And Self.J = .L.J Then
                                Projectile(L2).Activated = True
                                Projectile(L2).Direc = .Direc
                                Projectile(L2).L = .L
                                Projectile(L2).T = .Throws
                                Projectile(L2).UsedBySelf = False
                                L2 = 10
                            End If
                        Next
                    End If
                End If
            ElseIf .IntelligenceInt = 4 Then
                .Direc = Look3DAtVector2D(.L, Self)
                'This one slides over to meet you vertically
                If .Direc = 4 Then
                    DarkMakeMovement = True
                    .Direc = LeftDir
                Else
                    If .L.I < Self.I Then
                        .L = LookVector3D(.L, RightDir)
                        If CBool(InStr(1, "1235BEHIKLMbehiklmr+,()*PRT/vwxy?""#_`;", Left$(Map(.L.I, .L.J, .L.K), 1))) Then .L = LookVector3D(.L, LeftDir)
                    ElseIf .L.I > Self.I Then
                        .L = LookVector3D(.L, LeftDir)
                        If CBool(InStr(1, "1235BEHIKLMbehiklmr+,()*PRT/vwxy?""#_`;", Left$(Map(.L.I, .L.J, .L.K), 1))) Then .L = LookVector3D(.L, RightDir)
                    End If
                    If Self.J > .L.J Then
                        .Direc = DownDir
                    Else
                        .Direc = UpDir
                    End If
                    If DayClock Mod 60 = 43 Then
                        For L2 = 3 To 9
                            If Projectile(L2).Activated = False And Self.I = .L.I Then
                                Projectile(L2).Activated = True
                                Projectile(L2).Direc = .Direc
                                Projectile(L2).L = .L
                                Projectile(L2).T = .Throws
                                Projectile(L2).UsedBySelf = False
                                L2 = 10
                            End If
                        Next
                    End If
                End If
            End If
        End If
    End With
Next
End Function
Public Sub SwitchColor(SUrnj As Boolean, SGren As Boolean, SBlue As Boolean, MapLevel As Integer)
If SUrnj Then
    If LastTog = 0 Then
        LastTog = SecTog
        SecTog = 3 - SecTog
    End If
    If SecTog = 0 Then SecTog = 3 - LastTog
ElseIf SGren Then
    If LastTog = 1 Then
        LastTog = SecTog
        SecTog = 2 - SecTog
    End If
    If SecTog = 1 Then SecTog = 2 - LastTog
ElseIf SBlue Then
    If LastTog = 2 Then
        LastTog = SecTog
        SecTog = 1 - SecTog
    End If
    If SecTog = 2 Then SecTog = 1 - LastTog
End If
If SUrnj Then OnRed(MapLevel) = Not OnRed(MapLevel)
If SGren Then OnGreen(MapLevel) = Not OnGreen(MapLevel)
If SBlue Then OnBlue(MapLevel) = Not OnBlue(MapLevel)
If OnRed(MapLevel) = OnGreen(MapLevel) And OnGreen(MapLevel) = OnBlue(MapLevel) Then
    If LastTog = 0 Then SUrnj = True: OnRed(MapLevel) = Not OnRed(MapLevel)
    If LastTog = 1 Then SGren = True: OnGreen(MapLevel) = Not OnGreen(MapLevel)
    If LastTog = 2 Then SBlue = True: OnBlue(MapLevel) = Not OnBlue(MapLevel)
End If
For CV = 0 To BIGX - 1
    For RV = 0 To BIGY - 1
        X = Toggle(Map(CV, RV, MapLevel), "O", "P", SUrnj)  'Urnj (Orange)
        X = Toggle(Map(CV, RV, MapLevel), "S", "T", SGren)  'Green
        X = Toggle(Map(CV, RV, MapLevel), "Q", "R", SBlue)  'Blue
    Next
Next
End Sub
Public Function SeekValueInMap(ByVal Findthis As String, ByVal MapNumber As Integer, ByRef SkipVector As Vector2D, Optional ByVal StartAtX As Integer = 0, Optional ByVal StartAtY As Integer = 0) As Vector2D
Dim RV As Integer, CV As Integer
If IsEmpty(SkipVector.I) And IsEmpty(SkipVector.J) Then SkipVector.I = -1
For RV = StartAtY To BIGY - 1
    For CV = StartAtX To BIGX - 1
        If Map(CV, RV, MapNumber) = Findthis Then
            If CV <> SkipVector.I Or RV <> SkipVector.J Then
                SeekValueInMap.I = CV
                SeekValueInMap.J = RV
                CV = BIGX
                RV = BIGY
            End If
        End If
    Next
    StartAtX = 0
Next
End Function
Public Static Sub TidalForce(ByVal Mapnum As Integer)
Dim TideState As Byte, OldV As String, NewV As String
Dim RV As Integer, CV As Integer
TideState = TideState + 1
Select Case TideState
Case 1
    OldV = Chr23  'Flood first layer of soil
    NewV = "2A"
    For RV = 0 To BIGY - 1
        For CV = 0 To BIGX - 1
            If Map(CV, RV, Mapnum) = OldV Then Map(CV, RV, Mapnum) = NewV
        Next
    Next
Case 2
    OldV = Chr23  'Flood first layer of soil
    NewV = "2A"
    For RV = 0 To BIGY - 1
        For CV = 0 To BIGX - 1
            If Map(CV, RV, Mapnum) = OldV Then Map(CV, RV, Mapnum) = NewV
        Next
    Next
    OldV = Chr25
    NewV = "2B"
    For RV = 0 To BIGY - 1
        For CV = 0 To BIGX - 1
            If Map(CV, RV, Mapnum) = OldV Then Map(CV, RV, Mapnum) = NewV
        Next
    Next
Case 3
    OldV = Chr23  'Flood first layer of soil
    NewV = "2A"
    For RV = 0 To BIGY - 1
        For CV = 0 To BIGX - 1
            If Map(CV, RV, Mapnum) = OldV Then Map(CV, RV, Mapnum) = NewV
        Next
    Next
    OldV = Chr25
    NewV = "2B"
    For RV = 0 To BIGY - 1
        For CV = 0 To BIGX - 1
            If Map(CV, RV, Mapnum) = OldV Then Map(CV, RV, Mapnum) = NewV
        Next
    Next
    OldV = Chr24
    NewV = "2C"
    For RV = 0 To BIGY - 1
        For CV = 0 To BIGX - 1
            If Map(CV, RV, Mapnum) = OldV Then Map(CV, RV, Mapnum) = NewV
        Next
    Next
Case 4
    OldV = "2C"
    NewV = "2C"
Case 5
    OldV = "2C"
    NewV = Chr24
    For RV = 0 To BIGY - 1
        For CV = 0 To BIGX - 1
            If Map(CV, RV, Mapnum) = OldV Then Map(CV, RV, Mapnum) = NewV
        Next
    Next
Case 6
    OldV = "2C"
    NewV = Chr24
    For RV = 0 To BIGY - 1
        For CV = 0 To BIGX - 1
            If Map(CV, RV, Mapnum) = OldV Then Map(CV, RV, Mapnum) = NewV
        Next
    Next
    OldV = "2B"
    NewV = Chr25
    For RV = 0 To BIGY - 1
        For CV = 0 To BIGX - 1
            If Map(CV, RV, Mapnum) = OldV Then Map(CV, RV, Mapnum) = NewV
        Next
    Next
Case 7
    OldV = "2C"
    NewV = Chr24
    For RV = 0 To BIGY - 1
        For CV = 0 To BIGX - 1
            If Map(CV, RV, Mapnum) = OldV Then Map(CV, RV, Mapnum) = NewV
        Next
    Next
    OldV = "2B"
    NewV = Chr25
    For RV = 0 To BIGY - 1
        For CV = 0 To BIGX - 1
            If Map(CV, RV, Mapnum) = OldV Then Map(CV, RV, Mapnum) = NewV
        Next
    Next
    OldV = "2A"
    NewV = Chr23
    For RV = 0 To BIGY - 1
        For CV = 0 To BIGX - 1
            If Map(CV, RV, Mapnum) = OldV Then Map(CV, RV, Mapnum) = NewV
        Next
    Next
Case 8
    OldV = Chr23
    NewV = Chr23
    TideState = 0
End Select
End Sub
Public Function SkiPsn(ByVal T As Long, ByVal SkiNum As Integer) As Vector2D
SkiPsn.I = -1: SkiPsn.J = -1
Dim NewT As Long, NuT As Long
NewT = (T \ 25)
NuT = (T \ 5)
Select Case SkiNum
Case 0
    SkiPsn.J = 87
    Select Case NewT Mod 22
    Case 0 To 10
        SkiPsn.I = 55 + NewT Mod 22
    Case 11 To 21
        SkiPsn.I = 77 - NewT Mod 22
    End Select
Case 4
    SkiPsn.J = 39
    Select Case NewT Mod 16
    Case 0 To 7
        SkiPsn.I = 56 + NewT Mod 16
    Case 8 To 15
        SkiPsn.I = 72 - NewT Mod 16
    End Select
Case 8
    SkiPsn.I = 62
    Select Case NewT Mod 20
    Case 0 To 9
        SkiPsn.J = 26 + NewT Mod 20
    Case 10 To 19
        SkiPsn.J = 46 - NewT Mod 20
    End Select
Case 19
    SkiPsn.I = 91
    Select Case NewT Mod 24
    Case 0 To 11
        SkiPsn.J = 71 + NewT Mod 24
    Case 12 To 23
        SkiPsn.J = 95 - NewT Mod 24
    End Select
Case 20
    SkiPsn.I = 14
    Select Case NuT Mod 150
    Case 0 To 24
        SkiPsn.J = 63 + NuT Mod 150
    Case 25 To 74
        SkiPsn.J = 87
    Case 75 To 99
        SkiPsn.J = 163 - NuT Mod 150
    Case 100 To 149
        SkiPsn.J = 63
    End Select
Case 25
    SkiPsn.J = 12
    Select Case NuT Mod 126
    Case 0 To 12
        SkiPsn.I = 59 + NuT Mod 126
    Case 13 To 62
        SkiPsn.I = 71
    Case 63 To 75
        SkiPsn.I = 135 - NuT Mod 126
    Case 76 To 125
        SkiPsn.I = 59
    End Select
Case 32
    SkiPsn.J = 4
    Select Case NewT Mod 14
    Case 0 To 6
        SkiPsn.I = 95 + NewT Mod 14
    Case 7 To 13
        SkiPsn.I = 109 - NewT Mod 14
    End Select
Case 33
    SkiPsn.I = 94
    Select Case NuT Mod 120
    Case 0 To 39
        SkiPsn.J = 88
    Case 40 To 59
        SkiPsn.J = 128 - NuT Mod 120
    Case 60 To 79
        SkiPsn.J = NuT Mod 120 + 8
    Case 80 To 119
        SkiPsn.J = 88
    End Select
Case 35
    SkiPsn.J = 37
    Select Case NuT Mod 122
    Case 0 To 10
        SkiPsn.I = 61 + NuT Mod 122
    Case 11 To 60
        SkiPsn.I = 72
    Case 61 To 71
        SkiPsn.I = 133 - NuT Mod 122
    Case 72 To 121
        SkiPsn.I = 61
    End Select
Case 40
    SkiPsn.I = 54
    Select Case NewT Mod 16
    Case 0 To 7
        SkiPsn.J = 64 + NewT Mod 16
    Case 8 To 15
        SkiPsn.J = 80 - NewT Mod 16
    End Select
Case 60
    SkiPsn.J = 15
    Select Case NewT Mod 16
    Case 0 To 7
        SkiPsn.I = 87 + NewT Mod 16
    Case 8 To 15
        SkiPsn.I = 103 - NewT Mod 16
    End Select
Case 69
    SkiPsn.J = 34
    Select Case NuT Mod 116
    Case 0 To 7
        SkiPsn.I = 99 + NuT Mod 116
    Case 8 To 57
        SkiPsn.I = 107
    Case 58 To 65
        SkiPsn.I = 163 - NuT Mod 116
    Case 66 To 115
        SkiPsn.I = 99
    End Select
Case 71
    SkiPsn.I = 72
    Select Case NewT Mod 8
    Case 0 To 3
        SkiPsn.J = 73 + NewT Mod 8
    Case 4 To 7
        SkiPsn.J = 81 - NewT Mod 8
    End Select
Case 78
    SkiPsn.J = 70
    Select Case NewT Mod 8
    Case 0 To 3
        SkiPsn.I = 93 + NewT Mod 8
    Case 4 To 7
        SkiPsn.I = 101 - NewT Mod 8
    End Select
Case 83
    SkiPsn.J = 17
    Select Case NewT Mod 64
    Case 0 To 31
        SkiPsn.I = 78 + NewT Mod 64
    Case 32 To 63
        SkiPsn.I = 142 - NewT Mod 64
    End Select
Case 84
    SkiPsn.J = 32
    Select Case NewT Mod 36
    Case 0 To 17
        SkiPsn.I = 75 + NewT Mod 36
    Case 18 To 35
        SkiPsn.I = 111 - NewT Mod 36
    End Select
Case 85
    SkiPsn.J = 55
    Select Case NewT Mod 66
    Case 0 To 32
        SkiPsn.I = 48 + NewT Mod 66
    Case 33 To 65
        SkiPsn.I = 114 - NewT Mod 66
    End Select
Case 89
    SkiPsn.J = 79
    Select Case NuT Mod 120
    Case 0 To 9
        SkiPsn.I = 56 + NuT Mod 120
    Case 10 To 59
        SkiPsn.I = 66
    Case 60 To 69
        SkiPsn.I = 126 - NuT Mod 120
    Case 70 To 119
        SkiPsn.I = 56
    End Select
Case 91
    SkiPsn.I = 63
    Select Case NewT Mod 42
    Case 0 To 20
        SkiPsn.J = 41 + NewT Mod 42
    Case 21 To 41
        SkiPsn.J = 83 - NewT Mod 42
    End Select
Case 100
    SkiPsn.I = 14
    Select Case NewT Mod 24
    Case 0 To 11
        SkiPsn.J = 60 + NewT Mod 24
    Case 12 To 23
        SkiPsn.J = 84 - NewT Mod 24
    End Select
End Select
End Function
'Current position: 31,18,226
Public Function XW() As String
End Function
Public Function SkiPsn2(ByVal T As Long, ByVal SkiNum As Integer) As Vector2D
SkiPsn2.I = -1: SkiPsn2.J = -1
Dim NewT As Long, NuT As Long
NewT = (T \ 25)
NuT = (T \ 5)
Select Case SkiNum
Case 8
    SkiPsn2.I = 25
    Select Case NewT Mod 6
    Case 0 To 2
        SkiPsn2.J = 17 + NewT Mod 6
    Case 3 To 5
        SkiPsn2.J = 23 - NewT Mod 6
    End Select
Case 19
    SkiPsn2.J = 57
    Select Case NewT Mod 10
    Case 0 To 4
        SkiPsn2.I = 94 + NewT Mod 10
    Case 5 To 9
        SkiPsn2.I = 104 - NewT Mod 10
    End Select
Case 20
    SkiPsn2.I = 90
    Select Case NuT Mod 114
    Case 0 To 6
        SkiPsn2.J = 34 + NuT Mod 114
    Case 7 To 56
        SkiPsn2.J = 41
    Case 57 To 63
        SkiPsn2.J = 98 - NuT Mod 114
    Case 64 To 113
        SkiPsn2.J = 34
    End Select
Case 40
    SkiPsn2.J = 83
    Select Case NuT Mod 164
    Case 0 To 31
        SkiPsn2.I = 81 + NuT Mod 164
    Case 32 To 81
        SkiPsn2.I = 113
    Case 82 To 113
        SkiPsn2.I = 195 - NuT Mod 164
    Case 114 To 163
        SkiPsn2.I = 81
    End Select
Case 99
    SkiPsn2.I = 104
    Select Case NewT Mod 18
    Case 0 To 8
        SkiPsn2.J = 57 + NewT Mod 18
    Case 9 To 17
        SkiPsn2.J = 75 - NewT Mod 18
    End Select
Case 100
    SkiPsn2.I = 24
    Select Case NewT Mod 16
    Case 0 To 7
        SkiPsn2.J = 62 + NewT Mod 16
    Case 8 To 15
        SkiPsn2.J = 78 - NewT Mod 16
    End Select
End Select
End Function
'Load
Public Sub BeastPsn()   '(9,12)(23,21)
Dim T As Long, T2 As Long, T3 As Long, X As Byte
Static GoBeast As Long
T = DayClock \ 20
T2 = DayClock \ 5
T3 = DayClock \ 2
For X = 0 To 4
    Beast(X).I = -1
    Beast(X).J = -1
Next
Select Case MapID
Case 11
    Beast(0).I = 66
    Beast(1).I = 72
    Beast(2).I = 75
    Select Case T Mod 14
    Case 0 To 6
        Beast(0).J = 14 + T Mod 14
    Case 7 To 13
        Beast(0).J = 28 - T Mod 14
    End Select
    Beast(1).J = Beast(0).J
    Beast(2).J = Beast(1).J
Case 25
    Beast(0).I = 55
    Select Case T Mod 32
    Case 0 To 15
        Beast(0).J = 29 + T Mod 32
    Case 16 To 31
        Beast(0).J = 61 - T Mod 32
    End Select
    Select Case T Mod 14
    Case 0 To 3
        Beast(1).I = 72 + T Mod 14
        Beast(1).J = 37
    Case 4 To 6
        Beast(1).I = 76
        Beast(1).J = 33 + T Mod 14
    Case 7 To 10
        Beast(1).I = 83 - T Mod 14
        Beast(1).J = 40
    Case 11 To 13
        Beast(1).I = 72
        Beast(1).J = 51 - T Mod 14
    End Select
    Beast(2).I = 15
    Beast(3).I = 19
    Select Case T Mod 20
    Case 0 To 5
        Beast(2).J = 10 + T Mod 20
        Beast(3).J = 14 + T Mod 20
    Case 6 To 9
        Beast(2).J = 10 + T Mod 20
        Beast(3).J = 26 - T Mod 20
    Case 10 To 15
        Beast(2).J = 30 - T Mod 20
        Beast(3).J = 26 - T Mod 20
    Case 16 To 19
        Beast(2).J = 30 - T Mod 20
        Beast(3).J = T Mod 20 - 6
    End Select
Case 28
    Beast(0).J = 39
    Select Case T Mod 26
    Case 0 To 12
        Beast(0).I = 39 + T Mod 26
    Case 13 To 25
        Beast(0).I = 65 - T Mod 26
    End Select
Case 29
    Beast(0).I = 94
    Beast(0).J = 10
    If GoBeast > 0 Then
        Select Case (T2 - GoBeast) Mod 38
        Case 0 To 18
            Beast(0).J = 10 + (T2 - GoBeast) Mod 38
        Case 19 To 36
            Beast(0).J = 48 - (T2 - GoBeast) Mod 38
        Case 37
            GoBeast = 0
        End Select
    ElseIf Self.I = Beast(0).I Then
        GoBeast = T2
    End If
Case 31
    Beast(0).I = 40
    Select Case T Mod 28
    Case 0 To 13
        Beast(0).J = 58 + T Mod 28
    Case 14 To 27
        Beast(0).J = 86 - T Mod 28
    End Select
    Beast(1).I = 106
    Select Case T Mod 20
    Case 0 To 9
        Beast(1).J = 66 + T Mod 20
    Case 10 To 19
        Beast(1).J = 86 - T Mod 20
    End Select
Case 32
    Beast(0).I = 89
    Beast(0).J = 25
    If GoBeast > 0 Then
        Select Case (T2 - GoBeast) Mod 24
        Case 0 To 11
            Beast(0).J = 26 + (T2 - GoBeast) Mod 24
        Case 12 To 22
            Beast(0).J = 48 - (T2 - GoBeast) Mod 24
        Case 23
            GoBeast = 0
        End Select
    ElseIf Self.I = Beast(0).I Then
        GoBeast = T2
    End If
    Beast(1).I = 55
    Select Case T Mod 24
    Case 0 To 11
        Beast(1).J = 23 + T Mod 24
    Case 12 To 23
        Beast(1).J = 47 - T Mod 24
    End Select
Case 33
    Select Case T3 Mod 202
    Case 0 To 75
        Beast(0).I = 18 + T3 Mod 202
        Beast(0).J = 28
    Case 76 To 100
        Beast(0).I = 94
        Beast(0).J = T3 Mod 202 - 48
    Case 101 To 176
        Beast(0).I = 195 - T3 Mod 202
        Beast(0).J = 53
    Case 177 To 201
        Beast(0).I = 18
        Beast(0).J = 230 - T3 Mod 202
    End Select
    Beast(1).I = 112 - Beast(0).I
    Beast(1).J = 81 - Beast(0).J
    Select Case T3 Mod 140
    Case 0 To 21
        Beast(2).I = 51 + T3 Mod 140
        Beast(2).J = 53
    Case 22 To 69
        Beast(2).I = 73
        Beast(2).J = 75 - T3 Mod 140
    Case 70 To 91
        Beast(2).I = 143 - T3 Mod 140
        Beast(2).J = 5
    Case 92 To 139
        Beast(2).I = 51
        Beast(2).J = T3 Mod 140 - 87
    End Select
    Beast(3).I = 124 - Beast(2).I
    Beast(3).J = 58 - Beast(2).J
Case 34
    Beast(0).I = 98
    Beast(0).J = 34
    If GoBeast > 0 Then
        Select Case (T2 - GoBeast) Mod 20
        Case 0 To 9
            Beast(0).J = 35 + (T2 - GoBeast) Mod 20
        Case 10 To 18
            Beast(0).J = 53 - (T2 - GoBeast) Mod 20
        Case 29
            GoBeast = 0
        End Select
    ElseIf Self.I = Beast(0).I Then
        GoBeast = T2
    End If
Case 37
    Beast(0).I = 33
    Select Case T2 Mod 14
    Case 0 To 6
        Beast(0).J = 34 + T2 Mod 14
    Case 7 To 13
        Beast(0).J = 48 - T2 Mod 14
    End Select
    Beast(1).I = 46
    Select Case T2 Mod 60
    Case 0 To 29
        Beast(1).J = 44 + T2 Mod 60
    Case 30 To 59
        Beast(1).J = 104 - T2 Mod 60
    End Select
Case 46
    Beast(0).I = 81
    Select Case T Mod 10
    Case 0 To 4
        Beast(0).J = 27 + T Mod 10
    Case 5 To 9
        Beast(0).J = 37 - T Mod 10
    End Select
    Beast(1).I = 90
    Beast(1).J = Beast(0).J
    Beast(2).I = 94
    Beast(2).J = Beast(0).J
    Beast(3).I = 96
    Beast(3).J = Beast(0).J
Case 59
    Beast(0).J = 20
    Select Case T2 Mod 22
    Case 0 To 10
        Beast(0).I = 39 + T2 Mod 22
    Case 11 To 21
        Beast(0).I = 61 - T2 Mod 22
    End Select
Case 71
    Beast(0).J = 61
    Select Case T3 Mod 240
    Case 0 To 119
        Beast(0).I = T3 Mod 240
    Case 120 To 239
        Beast(0).I = 240 - T3 Mod 240
    End Select
    Beast(1).I = 104
    Select Case T3 Mod 180
    Case 0 To 89
        Beast(1).J = T3 Mod 180
    Case 90 To 179
        Beast(1).J = 180 - T3 Mod 180
    End Select
Case 72
    Beast(0).J = 61
    Select Case T3 Mod 240
    Case 0 To 119
        Beast(0).I = T3 Mod 240
    Case 120 To 239
        Beast(0).I = 240 - T3 Mod 240
    End Select
    Beast(1).I = 40
    Select Case T3 Mod 180
    Case 0 To 89
        Beast(1).J = T3 Mod 180
    Case 90 To 179
        Beast(1).J = 180 - T3 Mod 180
    End Select
Case 73
    Beast(0).J = 15
    Beast(1).J = 50
    Select Case T3 Mod 240
    Case 0 To 119
        Beast(0).I = T3 Mod 240
    Case 120 To 239
        Beast(0).I = 240 - T3 Mod 240
    End Select
    Beast(1).I = Beast(0).I
    Beast(2).I = 104
    Select Case T3 Mod 180
    Case 0 To 89
        Beast(2).J = T3 Mod 180
    Case 90 To 179
        Beast(2).J = 180 - T3 Mod 180
    End Select
Case 74
    Beast(0).J = 15
    Beast(1).J = 50
    Select Case T3 Mod 240
    Case 0 To 119
        Beast(0).I = T3 Mod 240
    Case 120 To 239
        Beast(0).I = 240 - T3 Mod 240
    End Select
    Beast(1).I = Beast(0).I
    Beast(2).I = 40
    Select Case T3 Mod 180
    Case 0 To 89
        Beast(2).J = T3 Mod 180
    Case 90 To 179
        Beast(2).J = 180 - T3 Mod 180
    End Select
Case 75
    Beast(0).J = 22
    Select Case T3 Mod 240
    Case 0 To 119
        Beast(0).I = T3 Mod 240
    Case 120 To 239
        Beast(0).I = 240 - T3 Mod 240
    End Select
    Beast(1).I = 104
    Select Case T3 Mod 180
    Case 0 To 89
        Beast(1).J = T3 Mod 180
    Case 90 To 179
        Beast(1).J = 180 - T3 Mod 180
    End Select
    Beast(2).I = 45
    Beast(2).J = 44
    If GoBeast > 0 Then
        Select Case (T2 - GoBeast) Mod 30
        Case 0 To 14
            Beast(2).J = 45 + (T2 - GoBeast) Mod 30
        Case 15 To 28
            Beast(2).J = 73 - (T2 - GoBeast) Mod 30
        Case 29
            GoBeast = 0
        End Select
    ElseIf Self.I = Beast(2).I Then
        GoBeast = T2
    End If
Case 76
    Beast(0).J = 22
    Select Case T3 Mod 240
    Case 0 To 119
        Beast(0).I = T3 Mod 240
    Case 120 To 239
        Beast(0).I = 240 - T3 Mod 240
    End Select
    Beast(1).I = 40
    Select Case T3 Mod 180
    Case 0 To 89
        Beast(1).J = T3 Mod 180
    Case 90 To 179
        Beast(1).J = 180 - T3 Mod 180
    End Select
Case 78
    Beast(0).I = 93
    Select Case T Mod 24
    Case 0 To 11
        Beast(0).J = 30 + T Mod 24
    Case 12 To 23
        Beast(0).J = 54 - T Mod 24
    End Select
Case 79
    Beast(0).I = 69
    Beast(0).J = 39
    If GoBeast > 0 Then
        Select Case (T2 - GoBeast) Mod 44
        Case 0 To 20
            Beast(0).J = 40 + (T2 - GoBeast) Mod 44
        Case 21 To 42
            Beast(0).J = 82 - (T2 - GoBeast) Mod 44
        Case 43
            GoBeast = 0
        End Select
    ElseIf Self.I = Beast(0).I Then
        GoBeast = T2
    End If
Case 81
    Beast(0).I = 67
    Beast(0).J = 36
    If GoBeast > 0 Then
        Select Case (T2 - GoBeast) Mod 62
        Case 0 To 29
            Beast(0).J = 37 + (T2 - GoBeast) Mod 62
        Case 30 To 60
            Beast(0).J = 97 - (T2 - GoBeast) Mod 62
        Case 61
            GoBeast = 0
        End Select
    ElseIf Self.I = Beast(0).I Then
        GoBeast = T2
    End If
    Beast(1).I = 80
    Select Case T2 Mod 54
    Case 0 To 26
        Beast(1).J = 5 + T2 Mod 54
    Case 27 To 53
        Beast(1).J = 59 - T2 Mod 54
    End Select
Case 82
    Beast(0).I = 91
    Select Case T2 Mod 24
    Case 0 To 11
        Beast(0).J = 44 + T2 Mod 24
    Case 12 To 23
        Beast(0).J = 68 - T2 Mod 24
    End Select
Case 84
    Beast(0).J = 18
    Select Case T2 Mod 76
    Case 0 To 37
        Beast(0).I = 68 + T2 Mod 76
    Case 38 To 75
        Beast(0).I = 144 - T2 Mod 76
    End Select
Case 85
    Beast(0).I = 62
    Beast(0).J = 55 + StepWave(T2 Mod 4)
Case 86
    Beast(0).J = 30
    Select Case T2 Mod 84
    Case 0 To 41
        Beast(0).I = 51 + T2 Mod 84
    Case 42 To 83
        Beast(0).I = 135 - T2 Mod 84
    End Select
Case 95
    Beast(0).I = 26
    Select Case T2 Mod 32
    Case 0 To 15
        Beast(0).J = 58 + T2 Mod 32
    Case 16 To 31
        Beast(0).J = 90 - T2 Mod 32
    End Select
Case 100
    Beast(0).J = 66
    Beast(1).J = 66
    Beast(0).I = 14 + StepWave(T2 Mod 4)
    Beast(1).I = Beast(0).I + 10
End Select
End Sub

Public Function NegFilter(ByVal Number As Double) As Currency
If Sgn(Number) = -1 Then
    NegFilter = 0
Else
    NegFilter = Number
End If
End Function
Public Function PosFilter(ByVal Number As Double) As Currency
If Sgn(Number) = 1 Then
    PosFilter = 0
Else
    PosFilter = Number
End If

End Function
Public Function Between(ByVal CValue As Single, ByVal Bound1 As Single, ByVal Bound2 As Single) As Boolean
    If (CValue >= Bound1 And CValue <= Bound2) Or (CValue <= Bound1 And CValue >= Bound2) Then Between = True
End Function
Public Function Toggle(ByRef SpyString As String, ByVal ValuStr1 As String, ByVal ValuStr2 As String, Optional Condition As Boolean = True) As String
If SpyString = ValuStr1 And Condition Then
    SpyString = ValuStr2
    Toggle = ValuStr2
ElseIf SpyString = ValuStr2 And Condition Then
    SpyString = ValuStr1
    Toggle = ValuStr1
Else
    Toggle = ""
End If
End Function
Public Function AddVector2D(VectorA As Vector2D, VectorB As Vector2D) As Vector2D
AddVector2D.I = VectorA.I + VectorB.I
AddVector2D.J = VectorA.J + VectorB.J
End Function
Public Function SubTractVector2D(VectorA As Vector2D, NegVect As Vector2D) As Vector2D
SubTractVector2D.I = VectorA.I - NegVect.I
SubTractVector2D.J = VectorA.J - NegVect.J
End Function
Public Function NegateVector2D(NegVect As Vector2D) As Vector2D
NegateVector2D.I = -NegVect.I
NegateVector2D.J = -NegVect.J
End Function
Public Function AddVector3D(VectorA As Vector3D, VectorB As Vector3D) As Vector3D
AddVector3D.I = VectorA.I + VectorB.I
AddVector3D.J = VectorA.J + VectorB.J
AddVector3D.K = VectorA.K + VectorB.K
End Function
Public Function SubTractVector3D(VectorA As Vector3D, NegVect As Vector3D) As Vector3D
SubTractVector3D.I = VectorA.I - NegVect.I
SubTractVector3D.J = VectorA.J - NegVect.J
SubTractVector3D.K = VectorA.K - NegVect.K
End Function
Public Function NegateVector3D(NegVect As Vector3D) As Vector3D
NegateVector3D.I = -NegVect.I
NegateVector3D.J = -NegVect.J
NegateVector3D.K = -NegVect.K
End Function
Public Function ScalarMultVector2D(VectorA As Vector2D, Scalar As Single) As Vector2D
ScalarMultVector2D.I = VectorA.I * Scalar
ScalarMultVector2D.J = VectorA.J * Scalar
End Function
Public Function ScalarMultVector3D(VectorA As Vector3D, Scalar As Single) As Vector3D
ScalarMultVector3D.I = VectorA.I * Scalar
ScalarMultVector3D.J = VectorA.J * Scalar
ScalarMultVector3D.K = VectorA.K * Scalar
End Function
Public Function PowerVector2D(VectorS As Vector2D, Tothe As Single) As Vector2D
PowerVector2D.I = VectorS.I ^ Tothe
PowerVector2D.J = VectorS.J ^ Tothe
End Function
Public Function PowerVector3D(VectorS As Vector3D, Tothe As Single) As Vector3D
PowerVector3D.I = VectorS.I ^ Tothe
PowerVector3D.J = VectorS.J ^ Tothe
PowerVector3D.K = VectorS.K ^ Tothe
End Function
Public Function Conv3Dto2D(ThreeDVector As Vector3D, KickDir As VCoords) As Vector2D
If KickDir <> Int(KickDir) Or KickDir < 0 Or KickDir > 2 Then KickDir = K_Coord
Select Case KickDir
Case 0
    Conv3Dto2D.I = ThreeDVector.J
    Conv3Dto2D.J = ThreeDVector.K
Case 1
    Conv3Dto2D.I = ThreeDVector.I
    Conv3Dto2D.J = ThreeDVector.K
Case 2
    Conv3Dto2D.I = ThreeDVector.I
    Conv3Dto2D.J = ThreeDVector.J
End Select
End Function
Public Function Conv2Dto3D(TwoDVector As Vector2D, Optional ZeroDir As VCoords) As Vector3D
If ZeroDir <> Int(ZeroDir) Or ZeroDir < 0 Or ZeroDir > 2 Or IsEmpty(ZeroDir) Then ZeroDir = K_Coord
Select Case ZeroDir
Case 0
    Conv2Dto3D.I = 0
    Conv2Dto3D.J = TwoDVector.I
    Conv2Dto3D.K = TwoDVector.J
Case 1
    Conv2Dto3D.I = TwoDVector.I
    Conv2Dto3D.J = 0
    Conv2Dto3D.K = TwoDVector.J
Case 2
    Conv2Dto3D.I = TwoDVector.I
    Conv2Dto3D.J = TwoDVector.J
    Conv2Dto3D.K = 0
End Select
End Function
Public Function Get2DLength(VectorA As Vector2D) As Double
Get2DLength = Sqr((VectorA.I ^ 2) + (VectorA.J ^ 2))
End Function
Public Function Get3DLength(VectorA As Vector3D) As Double
Get3DLength = Sqr((VectorA.I ^ 2) + (VectorA.J ^ 2) + (VectorA.K ^ 2))
End Function
Public Function GetUnitVector2D(VectorV As Vector2D) As Vector2D
Dim VLength As Double
VLength = Get2DLength(VectorV)
GetUnitVector2D.I = VectorV.I / VLength
GetUnitVector2D.J = VectorV.J / VLength
End Function
Public Function GetUnitVector3D(VectorV As Vector3D) As Vector3D
Dim VLength As Double
VLength = Get3DLength(VectorV)
GetUnitVector3D.I = VectorV.I / VLength
GetUnitVector3D.J = VectorV.J / VLength
GetUnitVector3D.K = VectorV.K / VLength
End Function
Public Function DotProduct2D(VectorA As Vector2D, VectorB As Vector2D) As Double
DotProduct2D = (VectorA.I * VectorB.I) + (VectorA.J * VectorB.J)
End Function
Public Function DotProduct3D(VectorA As Vector3D, VectorB As Vector3D) As Double
DotProduct3D = (VectorA.I * VectorB.I) + (VectorA.J * VectorB.J) + (VectorA.K * VectorB.K)
End Function
Public Function CrossProduct(FirstVect As Vector3D, CrossVect As Vector3D) As Vector3D
CrossProduct.I = (FirstVect.J * CrossVect.K) - (FirstVect.K * CrossVect.J)
CrossProduct.J = (FirstVect.I * CrossVect.K) - (FirstVect.K * CrossVect.I)
CrossProduct.K = (FirstVect.I * CrossVect.J) - (FirstVect.J * CrossVect.I)
End Function
Public Function EqualVector2D(VectorA As Vector2D, VectorB As Vector2D) As Boolean
If VectorA.I = VectorB.I And VectorA.J = VectorB.J Then EqualVector2D = True
End Function
Public Function EqualVector3D(VectorA As Vector3D, VectorB As Vector3D) As Boolean
If VectorA.I = VectorB.I And VectorA.J = VectorB.J And VectorA.K = VectorB.K Then EqualVector3D = True
End Function
Public Function AngleOf2D(VectorA As Vector2D) As Double
If VectorA.I = 0 Then AngleOf2D = Atn(1) / 2
AngleOf2D = Atn(VectorA.J / VectorA.I)
End Function
Public Function SubQuadrant(Origin As Vector2D, Probe As Vector2D) As Currency
If Origin.I < Probe.I And Origin.J > Probe.J Then SubQuadrant = 0
If Origin.I = Probe.I And Origin.J > Probe.J Then SubQuadrant = 0.5
If Origin.I > Probe.I And Origin.J > Probe.J Then SubQuadrant = 1
If Origin.I > Probe.I And Origin.J = Probe.J Then SubQuadrant = 1.5
If Origin.I > Probe.I And Origin.J < Probe.J Then SubQuadrant = 2
If Origin.I = Probe.I And Origin.J < Probe.J Then SubQuadrant = 2.5
If Origin.I < Probe.I And Origin.J < Probe.J Then SubQuadrant = 3
If Origin.I < Probe.I And Origin.J = Probe.J Then SubQuadrant = 3.5
End Function
Public Function LookVector2D(VectorA As Vector2D, ByVal Dir As Direction) As Vector2D
LookVector2D = VectorA
If Dir = LeftDir Then LookVector2D.I = LookVector2D.I - 1
If Dir = UpDir Then LookVector2D.J = LookVector2D.J - 1
If Dir = RightDir Then LookVector2D.I = LookVector2D.I + 1
If Dir = DownDir Then LookVector2D.J = LookVector2D.J + 1
End Function
Public Function LookVector3D(VectorA As Vector3D, ByVal Dir As Direction) As Vector3D
LookVector3D = VectorA
If Dir = LeftDir Then LookVector3D.I = LookVector3D.I - 1
If Dir = UpDir Then LookVector3D.J = LookVector3D.J - 1
If Dir = RightDir Then LookVector3D.I = LookVector3D.I + 1
If Dir = DownDir Then LookVector3D.J = LookVector3D.J + 1
End Function
Public Function SendX16Vector2D(Square As Control, Scaling As Single) As Vector2D
SendX16Vector2D.I = Square.Left \ Scaling
SendX16Vector2D.J = Square.Top \ Scaling
End Function
Public Function NameForDirection(Directio As Direction) As String
Select Case Directio
Case 0
    NameForDirection = "Left"
Case 1
    NameForDirection = "Up"
Case 2
    NameForDirection = "Right"
Case 3
    NameForDirection = "Down"
End Select
End Function
Public Function RunAnEvent(PDisplay As DirectDrawSurface7)
Dim LX As Integer, LY As Integer
Static rEvent(0 To 9) As Boolean
With PDisplay
    .SetFillStyle 0
    .SetFillColor 0
    .SetForeColor &HFFFFFF
    .DrawBox 0, 464, 600, 480
    .SetFontTransparency True
    Select Case MapID
    Case 7
        If rEvent(0) = False Then
            .DrawText 0, 464, "Timber!  Some distant trees have fallen.", False
            Sleep 2000
        End If
        Map(86, 82, 7) = "0"
        Map(86, 83, 7) = "0"
        Map(Self.I, Self.J, MapID) = "6"
        rEvent(0) = True
    Case 23
        For LX = 35 To 58
            For LY = 18 To 39
                Map(LX, LY, 23) = Chr$(48 + Int(Rnd * 1.6))
            Next
        Next
        .DrawText 0, 464, "Randomize!", False
        Sleep 250
    Case 43
        If rEvent(1) = False Then
            .DrawText 0, 464, "Welcome to Coineque di Pyreth Swamp!  Ha ha ha ha...", False
            Sleep 2000
            rEvent(1) = True
        End If
        For LX = 15 To 75 Step 10
            For LY = 15 To 85 Step 10
                Map(LX, LY, 43) = "^"
            Next
        Next
        Map(117, 80, 43) = "6"
        Map(Self.I, Self.J, MapID) = "6"
    Case 73
        If rEvent(3) = False Then
            .DrawText 0, 464, "Behold!  Red turns blue!", False
            Sleep 2000
            rEvent(3) = True
        End If
        Call Toggle(Map(90, 37, 73), "U", "V")
    Case 74
        If rEvent(2) = False Then
            .DrawText 0, 464, "Hiacojira Town has a history filled with secrets...", False
            Sleep 2000
            rEvent(2) = True
        End If
        Map(73, 65, 74) = "8"
        Map(63, 35, 74) = " "
        Map(63, 39, 74) = "0"
    Case 83
        For LX = 51 To 84
            For LY = 24 To 45
                Map(LX, LY, 83) = Chr$(48 + Int(Rnd * 1.6))
            Next
        Next
        .DrawText 0, 464, "Randomize!", False
        Sleep 250
    Case 92
        If rEvent(4) = False Then
            .DrawText 0, 464, "The gap becomes shorter, the ride becomes easier.", False
            Sleep 2000
            rEvent(4) = True
        End If
        Map(62, 41, 91) = "="
        Map(64, 62, 91) = "="
    Case 96
        If rEvent(5) = False Then
            .DrawText 0, 464, "Now you have access to the big island.", False
            Sleep 2000
            rEvent(5) = True
        End If
        Map(17, 23, 96) = "0"
        Map(18, 23, 96) = "0"
    End Select
End With
End Function
Public Sub CreateFog(ByRef LA() As Byte)
'The array dimensions are 0x0 to 4095x479 (4096x480)
'Hopefully this will create a dense fog effect using the locked array
Dim HoriZ As Integer, VeriZ As Integer
Dim CleaH As Integer, CleaV As Integer
Dim PixDis As Currency
CleaH = Self.I * 32 + 16
CleaV = Self.J * 16 + 8
For VeriZ = LBound(LA, 2) To UBound(LA, 2)
    For HoriZ = LBound(LA, 1) To UBound(LA, 1)
        PixDis = -PosFilter(Sqr(((HoriZ / 2) - CleaH) ^ 2 + (VeriZ - CleaV) ^ 2) - 160) / 160
        'If the distance from the character is >= 80 then PixDis = 0
        'If the distance from the character is 0 then PixDis = 1
        LA(HoriZ, VeriZ) = 255 - PixDis * (255 - LA(HoriZ, VeriZ))
    Next
Next
End Sub
Public Function SquareWave(ByVal Number As Double) As Double
Number = Abs(Number)
SquareWave = 1 - 2 * Int(Parasect(Number, 2))
End Function
Public Function TriangleWave(ByVal Number As Double) As Currency
TriangleWave = ((-2 * Number) * (SquareWave(Number))) + (((2 * Int(Number)) + 1) * (SquareWave(Number)))
End Function
Public Function HexagonWave(ByVal Number As Double) As Currency
Select Case (Int(Number) Mod 4)
Case 0
    HexagonWave = 2 * Parasect(Number, 4)
Case 1
    HexagonWave = 2
Case 2
    HexagonWave = -2 * Parasect(Number, 4) + 6
Case 3
    HexagonWave = 0
End Select
End Function
Public Function PulseishWave(ByVal Number As Double, Intensity As Double) As Currency
Select Case (Int(Number Mod (2 + Intensity)))
Case 0, 1
    PulseishWave = (2 - (Parasect(Number, 2 + Intensity))) ^ 4 / 16
Case 2 To (2 + Intensity)
    PulseishWave = 0
End Select
End Function
Public Function Parasect(ByVal Number As Currency, ByVal CartSize As Double)
If Number = Int(Number) Then
    Parasect = Number Mod CartSize
Else
    Do While Number > CartSize
        Number = Number - CartSize
    Loop
    Parasect = Number
End If
End Function
Public Sub TestClock()
For D = 700 To 850
Debug.Print -40 + Int(20 * PulseishWave(D / 34, 10))
Next
End Sub
'Current position: 10,5,237
'Current position: 37,3,244
'Current position: 37,27,244
Public Function SetVector3D(ByVal nI As Single, ByVal nJ As Single, ByVal nK As Single) As Vector3D
SetVector3D.I = nI
SetVector3D.J = nJ
SetVector3D.K = nK
End Function
Public Function Look3DAtVector2D(Beholder As Vector3D, Beholdee As Vector2D) As Direction
Dim Hrz As Boolean, Vtl As Boolean
If Beholder.I = Beholdee.I And Beholder.J = Beholdee.J Then Look3DAtVector2D = 4
If Abs(Beholder.I - Beholdee.I) > Abs(Beholder.J - Beholdee.J) Then Hrz = True
If Hrz Then
    If Beholder.I > Beholdee.I Then
        Look3DAtVector2D = LeftDir
    Else
        Look3DAtVector2D = RightDir
    End If
Else
    If Beholder.J > Beholdee.J Then
        Look3DAtVector2D = UpDir
    Else
        Look3DAtVector2D = DownDir
    End If
End If
End Function
